// A Bison parser, made by GNU Bison 3.7.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 11 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"

namespace hilti { namespace detail { class Parser; } }

#include <hilti/compiler/detail/parser/driver.h>

#line 39 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"


#include <hilti/compiler/detail/parser/scanner.h>

#undef yylex
#define yylex driver->scanner()->lex

static hilti::Meta toMeta(hilti::detail::parser::location l) {
    return hilti::Meta(hilti::Location(*l.begin.filename, l.begin.line, l.end.line, l.begin.column, l.end.column));
}

static hilti::Type iteratorForType(hilti::Type t, bool const_, hilti::Meta m) {
    if ( hilti::type::isIterable(t) )
        return t.iteratorType(const_);
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not iterable", t), m.location());
        return hilti::type::Error(m);
        }
}

static hilti::Type viewForType(hilti::Type t, hilti::Meta m) {
    if ( hilti::type::isViewable(t) )
        return t.viewType();
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not viewable", t), m.location());
        return hilti::type::Error(m);
        }
}

#define __loc__ toMeta(yylhs.location)


#line 80 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"


#include "__parser.h"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 27 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
namespace hilti { namespace detail { namespace parser {
#line 178 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"

  /// Build a parser object.
  Parser::Parser (class Driver* driver_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/

  // basic_symbol.
  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.copy< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.copy< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.copy< hilti::Declaration > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.copy< hilti::Function > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.copy< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.copy< hilti::Type > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.copy< hilti::statement::try_::Catch > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.copy< hilti::type::Flags > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.copy< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
        value.copy< hilti::type::function::Result > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.copy< std::optional<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.copy< std::vector<hilti::Declaration> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< std::vector<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.copy< std::vector<hilti::statement::try_::Catch> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.copy< std::vector<hilti::type::function::Parameter> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.copy< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }



  template <typename Base>
  Parser::symbol_kind_type
  Parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

  template <typename Base>
  bool
  Parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.move< hilti::Type > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.move< hilti::type::Flags > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_result: // func_result
        value.move< hilti::type::function::Result > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.move< std::optional<hilti::Expression> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.move< std::optional<hilti::Statement> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< std::vector<hilti::Declaration> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< std::vector<hilti::Statement> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< std::vector<hilti::statement::try_::Catch> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< std::vector<hilti::type::function::Parameter> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.move< uint64_t > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  Parser::by_kind::by_kind ()
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  Parser::by_kind::by_kind (by_kind&& that)
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  Parser::by_kind::by_kind (const by_kind& that)
    : kind_ (that.kind_)
  {}

  Parser::by_kind::by_kind (token_kind_type t)
    : kind_ (yytranslate_ (t))
  {}

  void
  Parser::by_kind::clear ()
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  Parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  Parser::symbol_kind_type
  Parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }

  Parser::symbol_kind_type
  Parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.YY_MOVE_OR_COPY< hilti::Attribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.YY_MOVE_OR_COPY< hilti::Ctor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.YY_MOVE_OR_COPY< hilti::Declaration > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.YY_MOVE_OR_COPY< hilti::Expression > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.YY_MOVE_OR_COPY< hilti::Function > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.YY_MOVE_OR_COPY< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.YY_MOVE_OR_COPY< hilti::Statement > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.YY_MOVE_OR_COPY< hilti::Type > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::map::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::struct_::Field > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.YY_MOVE_OR_COPY< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.YY_MOVE_OR_COPY< hilti::declaration::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.YY_MOVE_OR_COPY< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.YY_MOVE_OR_COPY< hilti::statement::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.YY_MOVE_OR_COPY< hilti::statement::try_::Catch > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.YY_MOVE_OR_COPY< hilti::type::Flags > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.YY_MOVE_OR_COPY< hilti::type::enum_::Label > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.YY_MOVE_OR_COPY< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.YY_MOVE_OR_COPY< hilti::type::function::Parameter > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
        value.YY_MOVE_OR_COPY< hilti::type::function::Result > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.YY_MOVE_OR_COPY< hilti::type::tuple::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.YY_MOVE_OR_COPY< std::optional<hilti::AttributeSet> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.YY_MOVE_OR_COPY< std::optional<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.YY_MOVE_OR_COPY< std::optional<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.YY_MOVE_OR_COPY< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.YY_MOVE_OR_COPY< std::vector<hilti::Declaration> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.YY_MOVE_OR_COPY< std::vector<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.YY_MOVE_OR_COPY< std::vector<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.YY_MOVE_OR_COPY< std::vector<hilti::ctor::map::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.YY_MOVE_OR_COPY< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.YY_MOVE_OR_COPY< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.YY_MOVE_OR_COPY< std::vector<hilti::statement::try_::Catch> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.YY_MOVE_OR_COPY< std::vector<hilti::type::enum_::Label> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.YY_MOVE_OR_COPY< std::vector<hilti::type::function::Parameter> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.YY_MOVE_OR_COPY< std::vector<hilti::type::tuple::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.YY_MOVE_OR_COPY< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.YY_MOVE_OR_COPY< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.move< hilti::Type > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.move< hilti::type::Flags > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
        value.move< hilti::type::function::Result > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.move< std::optional<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.move< std::optional<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< std::vector<hilti::Declaration> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< std::vector<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< std::vector<hilti::statement::try_::Catch> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< std::vector<hilti::type::function::Parameter> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.move< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute > (that.value);
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.copy< hilti::Declaration > (that.value);
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression > (that.value);
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.copy< hilti::Function > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.copy< hilti::ID > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement > (that.value);
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.copy< hilti::Type > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case > (that.value);
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.copy< hilti::statement::try_::Catch > (that.value);
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.copy< hilti::type::Flags > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.copy< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter > (that.value);
        break;

      case symbol_kind::S_func_result: // func_result
        value.copy< hilti::type::function::Result > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (that.value);
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.copy< std::optional<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.copy< std::vector<hilti::Declaration> > (that.value);
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< std::vector<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.copy< std::vector<hilti::statement::try_::Catch> > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.copy< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute > (that.value);
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration > (that.value);
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression > (that.value);
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement > (that.value);
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.move< hilti::Type > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case > (that.value);
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch > (that.value);
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.move< hilti::type::Flags > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter > (that.value);
        break;

      case symbol_kind::S_func_result: // func_result
        value.move< hilti::type::function::Result > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (that.value);
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.move< std::optional<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.move< std::optional<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< std::vector<hilti::Declaration> > (that.value);
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< std::vector<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< std::vector<hilti::statement::try_::Catch> > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YYUSE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 20 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
{
    yyla.location.begin.filename = yyla.location.end.filename = driver->currentFile();
}

#line 1961 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_CBOOL: // "bool value"
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_CUREAL: // "real value"
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_attribute: // attribute
        yylhs.value.emplace< hilti::Attribute > ();
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        yylhs.value.emplace< hilti::Ctor > ();
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        yylhs.value.emplace< hilti::Declaration > ();
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        yylhs.value.emplace< hilti::Expression > ();
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        yylhs.value.emplace< hilti::Function > ();
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        yylhs.value.emplace< hilti::ID > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        yylhs.value.emplace< hilti::Statement > ();
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        yylhs.value.emplace< hilti::Type > ();
        break;

      case symbol_kind::S_map_elem: // map_elem
        yylhs.value.emplace< hilti::ctor::map::Element > ();
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        yylhs.value.emplace< hilti::ctor::struct_::Field > ();
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        yylhs.value.emplace< hilti::declaration::Linkage > ();
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        yylhs.value.emplace< hilti::declaration::parameter::Kind > ();
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        yylhs.value.emplace< hilti::function::CallingConvention > ();
        break;

      case symbol_kind::S_switch_case: // switch_case
        yylhs.value.emplace< hilti::statement::switch_::Case > ();
        break;

      case symbol_kind::S_try_catch: // try_catch
        yylhs.value.emplace< hilti::statement::try_::Catch > ();
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        yylhs.value.emplace< hilti::type::Flags > ();
        break;

      case symbol_kind::S_enum_label: // enum_label
        yylhs.value.emplace< hilti::type::enum_::Label > ();
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        yylhs.value.emplace< hilti::type::function::Flavor > ();
        break;

      case symbol_kind::S_func_param: // func_param
        yylhs.value.emplace< hilti::type::function::Parameter > ();
        break;

      case symbol_kind::S_func_result: // func_result
        yylhs.value.emplace< hilti::type::function::Result > ();
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        yylhs.value.emplace< hilti::type::tuple::Element > ();
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        yylhs.value.emplace< std::optional<hilti::AttributeSet> > ();
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        yylhs.value.emplace< std::optional<hilti::Expression> > ();
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        yylhs.value.emplace< std::optional<hilti::Statement> > ();
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        yylhs.value.emplace< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ();
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        yylhs.value.emplace< std::vector<hilti::Declaration> > ();
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        yylhs.value.emplace< std::vector<hilti::Expression> > ();
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        yylhs.value.emplace< std::vector<hilti::Statement> > ();
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        yylhs.value.emplace< std::vector<hilti::ctor::map::Element> > ();
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        yylhs.value.emplace< std::vector<hilti::ctor::struct_::Field> > ();
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        yylhs.value.emplace< std::vector<hilti::statement::switch_::Case> > ();
        break;

      case symbol_kind::S_try_catches: // try_catches
        yylhs.value.emplace< std::vector<hilti::statement::try_::Catch> > ();
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        yylhs.value.emplace< std::vector<hilti::type::enum_::Label> > ();
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        yylhs.value.emplace< std::vector<hilti::type::function::Parameter> > ();
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        yylhs.value.emplace< std::vector<hilti::type::tuple::Element> > ();
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        yylhs.value.emplace< std::vector<std::string> > ();
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        yylhs.value.emplace< uint64_t > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // module: "module" local_id '{' global_scope_items '}'
#line 267 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { auto m = hilti::Module(yystack_[3].value.as < hilti::ID > (), std::move(yystack_[1].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first), std::move(yystack_[1].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second), __loc__);
                                                   driver->setDestinationModule(std::move(m));
                                                 }
#line 2338 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 3: // local_id: "identifier"
#line 274 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { std::string name(yystack_[0].value.as < std::string > ());

                                                   if ( name.find('-') != std::string::npos )
                                                       hilti::logger().error(util::fmt("Invalid ID '%s': cannot contain '-'", name), __loc__.location());
                                                   if ( name.substr(0, 2) == "__" && name != "__str__" )
                                                       hilti::logger().error(util::fmt("Invalid ID '%s': cannot start with '__'", name), __loc__.location());

                                                   yylhs.value.as < hilti::ID > () = hilti::ID(std::move(name), __loc__);
                                                 }
#line 2352 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 4: // scoped_id: local_id
#line 284 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2358 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 5: // scoped_id: "scoped identifier"
#line 285 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > (), __loc__); }
#line 2364 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 6: // $@1: %empty
#line 287 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                { driver->enableDottedIDMode(); }
#line 2370 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 7: // $@2: %empty
#line 289 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                { driver->disableDottedIDMode(); }
#line 2376 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 8: // dotted_id: $@1 "dotted identifier" $@2
#line 289 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                   { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[1].value.as < std::string > (), __loc__); }
#line 2382 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 9: // global_scope_items: global_scope_items global_scope_decl
#line 295 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first.push_back(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2388 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 10: // global_scope_items: global_scope_items stmt
#line 297 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second.push_back(yystack_[0].value.as < hilti::Statement > ()); }
#line 2394 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 11: // global_scope_items: %empty
#line 298 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = {}; }
#line 2400 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 12: // global_scope_decl: type_decl
#line 302 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2406 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 13: // global_scope_decl: constant_decl
#line 303 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2412 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 14: // global_scope_decl: global_decl
#line 304 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2418 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 15: // global_scope_decl: function_decl
#line 305 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2424 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 16: // global_scope_decl: import_decl
#line 306 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2430 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 17: // global_scope_decl: property_decl
#line 307 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2436 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 18: // type_decl: opt_linkage "type" scoped_id '=' type opt_attributes ';'
#line 310 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Type(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), std::move(yystack_[6].value.as < hilti::declaration::Linkage > ()), __loc__); }
#line 2442 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 19: // constant_decl: opt_linkage "const" scoped_id '=' expr ';'
#line 313 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Constant(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2448 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 20: // constant_decl: opt_linkage "const" type scoped_id '=' expr ';'
#line 315 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Constant(yystack_[3].value.as < hilti::ID > (), yystack_[4].value.as < hilti::Type > (), yystack_[1].value.as < hilti::Expression > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2454 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 21: // local_decl: "local" local_id '=' expr ';'
#line 318 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), false, __loc__); }
#line 2460 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 22: // local_decl: "local" type local_id opt_type_arguments ';'
#line 319 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                          { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), yystack_[1].value.as < std::vector<hilti::Expression> > (), {}, false, __loc__); }
#line 2466 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 23: // local_decl: "local" type local_id '=' expr ';'
#line 321 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[4].value.as < hilti::Type > (), yystack_[1].value.as < hilti::Expression > (), false, __loc__); }
#line 2472 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 24: // local_decl: "local" "auto" local_id '=' expr ';'
#line 323 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), false, __loc__); }
#line 2478 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 25: // local_init_decl: "local" type local_id '=' expr
#line 328 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), yystack_[0].value.as < hilti::Expression > (), false, __loc__); }
#line 2484 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 26: // local_init_decl: "local" "auto" local_id '=' expr
#line 330 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[0].value.as < hilti::Expression > (), false, __loc__); }
#line 2490 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 27: // global_decl: opt_linkage "global" scoped_id '=' expr ';'
#line 334 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2496 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 28: // global_decl: opt_linkage "global" type scoped_id opt_type_arguments ';'
#line 336 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), yystack_[1].value.as < std::vector<hilti::Expression> > (), {}, yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2502 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 29: // global_decl: opt_linkage "global" type scoped_id '=' expr ';'
#line 338 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[4].value.as < hilti::Type > (), yystack_[1].value.as < hilti::Expression > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2508 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 30: // global_decl: opt_linkage "global" "auto" scoped_id '=' expr ';'
#line 340 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2514 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 31: // opt_type_arguments: '(' opt_exprs ')'
#line 344 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()); }
#line 2520 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 32: // opt_type_arguments: %empty
#line 345 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<Expression>{}; }
#line 2526 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 33: // function_decl: opt_linkage "function" function_with_body
#line 348 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Function(yystack_[0].value.as < hilti::Function > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2532 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 34: // function_decl: opt_linkage "hook" hook_with_body
#line 349 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                             { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Function(yystack_[0].value.as < hilti::Function > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2538 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 35: // function_decl: "method" method_with_body
#line 352 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Function(yystack_[0].value.as < hilti::Function > (), hilti::declaration::Linkage::Struct, __loc__); }
#line 2544 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 36: // function_decl: "declare" opt_linkage function_without_body ';'
#line 354 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Function(yystack_[1].value.as < hilti::Function > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2550 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 37: // import_decl: "import" local_id ';'
#line 357 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[1].value.as < hilti::ID > ()), std::string(".hlt"), __loc__); }
#line 2556 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 38: // import_decl: "import" local_id "from" dotted_id ';'
#line 358 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                   { yylhs.value.as < hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[3].value.as < hilti::ID > ()), std::string(".hlt"), std::move(yystack_[1].value.as < hilti::ID > ()), __loc__); }
#line 2562 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 39: // property_decl: "property" ';'
#line 362 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[1].value.as < std::string > ())), __loc__); }
#line 2568 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 40: // property_decl: "property" '=' expr ';'
#line 363 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[3].value.as < std::string > ())), std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 2574 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 41: // opt_linkage: "public"
#line 365 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Public; }
#line 2580 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 42: // opt_linkage: "private"
#line 366 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 2586 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 43: // opt_linkage: "init"
#line 367 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Init; }
#line 2592 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 44: // opt_linkage: "preinit"
#line 368 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::PreInit; }
#line 2598 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 45: // opt_linkage: %empty
#line 369 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 2604 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 46: // function_id: local_id
#line 373 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2610 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 47: // function_id: "~finally"
#line 374 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID("~finally", __loc__); }
#line 2616 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 48: // scoped_function_id: function_id
#line 377 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2622 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 49: // scoped_function_id: "scoped identifier"
#line 378 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > (), __loc__); }
#line 2628 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 50: // scoped_function_id: "scoped ~finally"
#line 379 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > (), __loc__); }
#line 2634 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 51: // function_with_body: opt_func_cc func_result scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 383 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 {
                                                    auto ftype = hilti::type::Function(yystack_[6].value.as < hilti::type::function::Result > (), yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > (), type::function::Flavor::Standard, __loc__);
                                                    yylhs.value.as < hilti::Function > () = hilti::Function(yystack_[5].value.as < hilti::ID > (), std::move(ftype), yystack_[0].value.as < hilti::Statement > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 2643 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 52: // method_with_body: opt_func_cc func_result scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 390 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 {
                                                    auto ftype = hilti::type::Function(yystack_[6].value.as < hilti::type::function::Result > (), yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > (), type::function::Flavor::Method, __loc__);
                                                    yylhs.value.as < hilti::Function > () = hilti::Function(yystack_[5].value.as < hilti::ID > (), std::move(ftype), yystack_[0].value.as < hilti::Statement > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 2652 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 53: // hook_with_body: opt_func_cc func_result scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 397 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 {
                                                    auto ftype = hilti::type::Function(yystack_[6].value.as < hilti::type::function::Result > (), yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > (), type::function::Flavor::Hook, __loc__);
                                                    yylhs.value.as < hilti::Function > () = hilti::Function(yystack_[5].value.as < hilti::ID > (), std::move(ftype), yystack_[0].value.as < hilti::Statement > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 2661 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 54: // function_without_body: opt_func_flavor opt_func_cc func_result scoped_function_id '(' opt_func_params ')' opt_attributes
#line 404 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 {
                                                    auto ftype = hilti::type::Function(yystack_[5].value.as < hilti::type::function::Result > (), yystack_[2].value.as < std::vector<hilti::type::function::Parameter> > (), yystack_[7].value.as < hilti::type::function::Flavor > (), __loc__);
                                                    yylhs.value.as < hilti::Function > () = hilti::Function(yystack_[4].value.as < hilti::ID > (), std::move(ftype), {}, yystack_[6].value.as < hilti::function::CallingConvention > (), yystack_[0].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 2670 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 55: // opt_func_flavor: func_flavor
#line 409 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = yystack_[0].value.as < hilti::type::function::Flavor > (); }
#line 2676 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 56: // opt_func_flavor: %empty
#line 410 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Standard; }
#line 2682 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 57: // func_flavor: "method"
#line 412 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Method; }
#line 2688 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 58: // func_flavor: "hook"
#line 413 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Hook; }
#line 2694 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 59: // opt_func_cc: "extern"
#line 415 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::Extern; }
#line 2700 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 60: // opt_func_cc: "extern-no-suspend"
#line 416 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::ExternNoSuspend; }
#line 2706 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 61: // opt_func_cc: %empty
#line 417 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::Standard; }
#line 2712 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 62: // opt_func_params: func_params
#line 419 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[0].value.as < std::vector<hilti::type::function::Parameter> > ()); }
#line 2718 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 63: // opt_func_params: %empty
#line 420 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 2724 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 64: // func_params: func_params ',' func_param
#line 422 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                         { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[2].value.as < std::vector<hilti::type::function::Parameter> > ()); yylhs.value.as < std::vector<hilti::type::function::Parameter> > ().push_back(yystack_[0].value.as < hilti::type::function::Parameter > ()); }
#line 2730 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 65: // func_params: func_param
#line 423 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{yystack_[0].value.as < hilti::type::function::Parameter > ()}; }
#line 2736 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 66: // func_param: opt_func_param_kind type local_id opt_func_default_expr opt_attributes
#line 426 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Parameter > () = hilti::type::function::Parameter(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), yystack_[4].value.as < hilti::declaration::parameter::Kind > (), yystack_[1].value.as < std::optional<hilti::Expression> > (), yystack_[0].value.as < std::optional<hilti::AttributeSet> > (), __loc__); }
#line 2742 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 67: // func_result: type
#line 429 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Result > () = hilti::type::function::Result(std::move(yystack_[0].value.as < hilti::Type > ()), __loc__); }
#line 2748 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 68: // opt_func_param_kind: "copy"
#line 432 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::Copy; }
#line 2754 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 69: // opt_func_param_kind: "inout"
#line 433 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::InOut; }
#line 2760 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 70: // opt_func_param_kind: %empty
#line 434 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::In; }
#line 2766 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 71: // opt_func_default_expr: '=' expr
#line 437 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 2772 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 72: // opt_func_default_expr: %empty
#line 438 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = {}; }
#line 2778 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 73: // block: braced_block
#line 443 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = std::move(yystack_[0].value.as < hilti::Statement > ()); }
#line 2784 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 74: // block: stmt
#line 444 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Block({yystack_[0].value.as < hilti::Statement > ()}, __loc__); }
#line 2790 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 75: // braced_block: '{' opt_stmts '}'
#line 447 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Block(std::move(yystack_[1].value.as < std::vector<hilti::Statement> > ()), __loc__); }
#line 2796 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 76: // opt_stmts: stmts
#line 449 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::move(yystack_[0].value.as < std::vector<hilti::Statement> > ()); }
#line 2802 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 77: // opt_stmts: %empty
#line 450 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{}; }
#line 2808 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 78: // stmts: stmts stmt
#line 452 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::move(yystack_[1].value.as < std::vector<hilti::Statement> > ()); yylhs.value.as < std::vector<hilti::Statement> > ().push_back(yystack_[0].value.as < hilti::Statement > ()); }
#line 2814 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 79: // stmts: stmt
#line 453 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{std::move(yystack_[0].value.as < hilti::Statement > ())}; }
#line 2820 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 80: // stmt: stmt_expr ';'
#line 455 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = std::move(yystack_[1].value.as < hilti::Statement > ()); }
#line 2826 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 81: // stmt: stmt_decl
#line 456 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = std::move(yystack_[0].value.as < hilti::Statement > ()); }
#line 2832 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 82: // stmt: "return" ';'
#line 457 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Return(__loc__); }
#line 2838 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 83: // stmt: "return" expr ';'
#line 458 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Return(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 2844 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 84: // stmt: "throw" expr ';'
#line 459 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Throw(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 2850 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 85: // stmt: "throw" ';'
#line 460 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Throw(__loc__); }
#line 2856 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 86: // stmt: "yield" ';'
#line 461 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Yield(__loc__); }
#line 2862 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 87: // stmt: "break" ';'
#line 462 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Break(__loc__); }
#line 2868 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 88: // stmt: "continue" ';'
#line 463 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Continue(__loc__); }
#line 2874 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 89: // stmt: "if" '(' expr ')' block opt_else_block
#line 465 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2880 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 90: // stmt: "if" '(' local_init_decl ')' block opt_else_block
#line 467 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as < hilti::Declaration > ()), {}, std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2886 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 91: // stmt: "if" '(' local_init_decl ';' expr ')' block opt_else_block
#line 469 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::If(std::move(yystack_[5].value.as < hilti::Declaration > ()), std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2892 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 92: // stmt: "while" '(' local_init_decl ';' expr ')' block opt_else_block
#line 471 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::While(std::move(yystack_[5].value.as < hilti::Declaration > ()), std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2898 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 93: // stmt: "while" '(' expr ')' block opt_else_block
#line 473 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::While(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2904 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 94: // stmt: "while" '(' local_init_decl ')' block opt_else_block
#line 475 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::While(std::move(yystack_[3].value.as < hilti::Declaration > ()), {}, std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2910 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 95: // stmt: "for" '(' local_id "in" expr ')' block
#line 477 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::For(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 2916 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 96: // stmt: "switch" '(' expr ')' '{' opt_switch_cases '}'
#line 479 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 2922 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 97: // stmt: "switch" '(' local_init_decl ')' '{' opt_switch_cases '}'
#line 481 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as < hilti::Declaration > ()), std::move(yystack_[1].value.as < std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 2928 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 98: // stmt: "try" block try_catches
#line 483 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Try(std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::vector<hilti::statement::try_::Catch> > ()), __loc__); }
#line 2934 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 99: // stmt: "assert" expr ';'
#line 484 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[1].value.as < hilti::Expression > ()), {}, __loc__); }
#line 2940 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 100: // stmt: "assert" expr ':' expr ';'
#line 485 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 2946 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 101: // stmt: "assert-exception" expr ';'
#line 486 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[1].value.as < hilti::Expression > ()), {}, {}, __loc__); }
#line 2952 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 102: // stmt: "assert-exception" expr ':' expr ';'
#line 488 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[3].value.as < hilti::Expression > ()), {}, std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 2958 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 103: // stmt: "add" expr ';'
#line 490 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { auto op = yystack_[1].value.as < hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'add' must be used with index expression only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Add, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 2970 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 104: // stmt: "delete" expr ';'
#line 498 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { auto op = yystack_[1].value.as < hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'delete' must be used with index expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Delete, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 2982 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 105: // stmt: "unset" expr ';'
#line 506 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { auto op = yystack_[1].value.as < hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Member) )
                                                        error(yylhs.location, "'unset' must be used with member expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unset, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 2994 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 106: // opt_else_block: "else" block
#line 516 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Statement> > () = std::move(yystack_[0].value.as < hilti::Statement > ()); }
#line 3000 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 107: // opt_else_block: %empty
#line 517 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Statement> > () = {}; }
#line 3006 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 108: // opt_switch_cases: switch_cases
#line 520 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::switch_::Case> > () = std::move(yystack_[0].value.as < std::vector<hilti::statement::switch_::Case> > ()); }
#line 3012 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 109: // opt_switch_cases: %empty
#line 521 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::switch_::Case> > () = {}; }
#line 3018 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 110: // switch_cases: switch_cases switch_case
#line 523 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::switch_::Case> > () = std::move(yystack_[1].value.as < std::vector<hilti::statement::switch_::Case> > ()); yylhs.value.as < std::vector<hilti::statement::switch_::Case> > ().push_back(std::move(yystack_[0].value.as < hilti::statement::switch_::Case > ())); }
#line 3024 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 111: // switch_cases: switch_case
#line 524 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::switch_::Case> > () = std::vector<hilti::statement::switch_::Case>({ std::move(yystack_[0].value.as < hilti::statement::switch_::Case > ()) }); }
#line 3030 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 112: // switch_case: "case" exprs ':' block
#line 526 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(std::move(yystack_[2].value.as < std::vector<hilti::Expression> > ()), std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 3036 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 113: // switch_case: "default" ':' block
#line 527 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(hilti::statement::switch_::Default(), std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 3042 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 114: // try_catches: try_catches try_catch
#line 529 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::try_::Catch> > () = std::move(yystack_[1].value.as < std::vector<hilti::statement::try_::Catch> > ()); yylhs.value.as < std::vector<hilti::statement::try_::Catch> > ().push_back(std::move(yystack_[0].value.as < hilti::statement::try_::Catch > ())); }
#line 3048 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 115: // try_catches: try_catch
#line 530 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::try_::Catch> > () = std::vector<hilti::statement::try_::Catch>({ std::move(yystack_[0].value.as < hilti::statement::try_::Catch > ()) }); }
#line 3054 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 116: // try_catch: "catch" '(' type local_id ')' block
#line 533 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::statement::try_::Catch > () = hilti::statement::try_::Catch(declaration::Parameter(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), declaration::parameter::Kind::In, {}, __loc__), std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 3060 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 117: // try_catch: "catch" block
#line 534 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::statement::try_::Catch > () = hilti::statement::try_::Catch(std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 3066 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 118: // stmt_decl: local_decl
#line 536 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as < hilti::Declaration > (), __loc__); }
#line 3072 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 119: // stmt_decl: type_decl
#line 537 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as < hilti::Declaration > (), __loc__); }
#line 3078 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 120: // stmt_decl: constant_decl
#line 538 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as < hilti::Declaration > (), __loc__); }
#line 3084 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 121: // stmt_expr: expr
#line 541 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(yystack_[0].value.as < hilti::Expression > (), __loc__); }
#line 3090 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 122: // base_type_no_attrs: "any"
#line 546 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Any(__loc__); }
#line 3096 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 123: // base_type_no_attrs: "addr"
#line 547 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Address(__loc__); }
#line 3102 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 124: // base_type_no_attrs: "auto"
#line 548 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::auto_; }
#line 3108 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 125: // base_type_no_attrs: "bool"
#line 549 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Bool(__loc__); }
#line 3114 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 126: // base_type_no_attrs: "bytes"
#line 550 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Bytes(__loc__); }
#line 3120 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 127: // base_type_no_attrs: "error"
#line 551 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Error(__loc__); }
#line 3126 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 128: // base_type_no_attrs: "interval"
#line 552 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Interval(__loc__); }
#line 3132 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 129: // base_type_no_attrs: "net"
#line 553 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Network(__loc__); }
#line 3138 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 130: // base_type_no_attrs: "port"
#line 554 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Port(__loc__); }
#line 3144 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 131: // base_type_no_attrs: "real"
#line 555 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Real(__loc__); }
#line 3150 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 132: // base_type_no_attrs: "regexp"
#line 556 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::RegExp(__loc__); }
#line 3156 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 133: // base_type_no_attrs: "stream"
#line 557 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Stream(__loc__); }
#line 3162 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 134: // base_type_no_attrs: "string"
#line 558 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::String(__loc__); }
#line 3168 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 135: // base_type_no_attrs: "time"
#line 559 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Time(__loc__); }
#line 3174 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 136: // base_type_no_attrs: "void"
#line 560 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::void_; }
#line 3180 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 137: // base_type_no_attrs: "int" type_param_begin "unsigned integer value" type_param_end
#line 562 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::SignedInteger(yystack_[1].value.as < uint64_t > (), __loc__); }
#line 3186 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 138: // base_type_no_attrs: "int" type_param_begin '*' type_param_end
#line 563 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::SignedInteger(hilti::type::Wildcard(), __loc__); }
#line 3192 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 139: // base_type_no_attrs: "uint" type_param_begin "unsigned integer value" type_param_end
#line 564 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::UnsignedInteger(yystack_[1].value.as < uint64_t > (), __loc__); }
#line 3198 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 140: // base_type_no_attrs: "uint" type_param_begin '*' type_param_end
#line 565 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::UnsignedInteger(hilti::type::Wildcard(), __loc__); }
#line 3204 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 141: // base_type_no_attrs: "optional" type_param_begin type type_param_end
#line 567 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Optional(yystack_[1].value.as < hilti::Type > (), __loc__); }
#line 3210 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 142: // base_type_no_attrs: "result" type_param_begin type type_param_end
#line 568 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Result(yystack_[1].value.as < hilti::Type > (), __loc__); }
#line 3216 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 143: // base_type_no_attrs: "view" type_param_begin type type_param_end
#line 569 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = viewForType(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3222 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 144: // base_type_no_attrs: "iterator" type_param_begin type type_param_end
#line 570 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as < hilti::Type > ()), false, __loc__); }
#line 3228 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 145: // base_type_no_attrs: "const_iterator" type_param_begin type type_param_end
#line 571 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as < hilti::Type > ()), true, __loc__); }
#line 3234 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 146: // base_type_no_attrs: "strong_ref" type_param_begin type type_param_end
#line 572 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::StrongReference(yystack_[1].value.as < hilti::Type > (), __loc__); }
#line 3240 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 147: // base_type_no_attrs: "strong_ref" type_param_begin '*' type_param_end
#line 573 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::StrongReference(hilti::type::Wildcard(), __loc__); }
#line 3246 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 148: // base_type_no_attrs: "value_ref" type_param_begin type type_param_end
#line 574 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::ValueReference(yystack_[1].value.as < hilti::Type > (), __loc__); }
#line 3252 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 149: // base_type_no_attrs: "value_ref" type_param_begin '*' type_param_end
#line 575 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::ValueReference(hilti::type::Wildcard(), __loc__); }
#line 3258 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 150: // base_type_no_attrs: "weak_ref" type_param_begin type type_param_end
#line 576 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::WeakReference(yystack_[1].value.as < hilti::Type > (), __loc__); }
#line 3264 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 151: // base_type_no_attrs: "weak_ref" type_param_begin '*' type_param_end
#line 577 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::WeakReference(hilti::type::Wildcard(), __loc__); }
#line 3270 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 152: // base_type_no_attrs: "list" type_param_begin '*' type_param_end
#line 579 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::List(hilti::type::Wildcard(), __loc__); }
#line 3276 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 153: // base_type_no_attrs: "list" type_param_begin type type_param_end
#line 580 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::List(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3282 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 154: // base_type_no_attrs: "vector" type_param_begin '*' type_param_end
#line 581 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Vector(hilti::type::Wildcard(), __loc__); }
#line 3288 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 155: // base_type_no_attrs: "vector" type_param_begin type type_param_end
#line 582 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Vector(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3294 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 156: // base_type_no_attrs: "set" type_param_begin '*' type_param_end
#line 583 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Set(hilti::type::Wildcard(), __loc__); }
#line 3300 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 157: // base_type_no_attrs: "set" type_param_begin type type_param_end
#line 584 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Set(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3306 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 158: // base_type_no_attrs: "map" type_param_begin '*' type_param_end
#line 585 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Map(hilti::type::Wildcard(), __loc__); }
#line 3312 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 159: // base_type_no_attrs: "map" type_param_begin type ',' type type_param_end
#line 586 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Map(std::move(yystack_[3].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3318 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 160: // base_type_no_attrs: "exception"
#line 588 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Exception(__loc__); }
#line 3324 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 161: // base_type_no_attrs: "exception" ':' type
#line 589 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Exception(std::move(yystack_[0].value.as < hilti::Type > ()), __loc__); }
#line 3330 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 162: // base_type_no_attrs: "library type" '(' "string value" ')'
#line 591 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Library(std::move(yystack_[1].value.as < std::string > ()), __loc__); }
#line 3336 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 163: // base_type_no_attrs: tuple_type
#line 593 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3342 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 164: // base_type_no_attrs: struct_type
#line 594 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3348 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 165: // base_type_no_attrs: union_type
#line 595 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3354 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 166: // base_type_no_attrs: enum_type
#line 596 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3360 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 167: // base_type: base_type_no_attrs opt_type_flags
#line 600 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = type::addFlags(yystack_[1].value.as < hilti::Type > (), yystack_[0].value.as < hilti::type::Flags > ()); }
#line 3366 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 168: // type: base_type
#line 603 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3372 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 169: // type: function_type
#line 604 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3378 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 170: // type: scoped_id
#line 605 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::UnresolvedID(std::move(yystack_[0].value.as < hilti::ID > ())); }
#line 3384 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 171: // type_param_begin: '<'
#line 610 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
              { driver->disableExpressionMode(); }
#line 3390 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 172: // type_param_end: '>'
#line 614 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
              { driver->enableExpressionMode(); }
#line 3396 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 173: // opt_type_flags: %empty
#line 616 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::Flags > () = hilti::type::Flags(); }
#line 3402 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 174: // function_type: opt_func_flavor "function" '(' opt_func_params ')' "->" func_result
#line 620 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Function(yystack_[0].value.as < hilti::type::function::Result > (), yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > (), yystack_[6].value.as < hilti::type::function::Flavor > (), __loc__); }
#line 3408 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 175: // tuple_type: "tuple" type_param_begin '*' type_param_end
#line 623 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Tuple(hilti::type::Wildcard(), __loc__); }
#line 3414 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 176: // tuple_type: "tuple" type_param_begin tuple_type_elems type_param_end
#line 624 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::type::tuple::Element> > ()), __loc__); }
#line 3420 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 177: // tuple_type_elems: tuple_type_elems ',' tuple_type_elem
#line 629 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::tuple::Element> > () = std::move(yystack_[2].value.as < std::vector<hilti::type::tuple::Element> > ()); yylhs.value.as < std::vector<hilti::type::tuple::Element> > ().push_back(std::move(yystack_[0].value.as < hilti::type::tuple::Element > ())); }
#line 3426 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 178: // tuple_type_elems: tuple_type_elem
#line 630 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::tuple::Element> > () = std::vector<hilti::type::tuple::Element>{ std::move(yystack_[0].value.as < hilti::type::tuple::Element > ()) }; }
#line 3432 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 179: // tuple_type_elem: type
#line 634 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::tuple::Element > () = hilti::type::tuple::Element(hilti::ID(), std::move(yystack_[0].value.as < hilti::Type > ()), __loc__); }
#line 3438 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 180: // tuple_type_elem: local_id ':' type
#line 635 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::tuple::Element > () = hilti::type::tuple::Element(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < hilti::Type > ()), __loc__); }
#line 3444 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 181: // struct_type: "struct" opt_struct_params '{' struct_fields '}'
#line 638 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                   { yylhs.value.as < hilti::Type > () = hilti::type::Struct(std::move(yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > ()), std::move(yystack_[1].value.as < std::vector<hilti::Declaration> > ()), __loc__); }
#line 3450 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 182: // opt_struct_params: '(' opt_func_params ')'
#line 641 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[1].value.as < std::vector<hilti::type::function::Parameter> > ()); }
#line 3456 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 183: // opt_struct_params: %empty
#line 642 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 3462 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 184: // struct_fields: struct_fields struct_field
#line 644 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::move(yystack_[1].value.as < std::vector<hilti::Declaration> > ()); yylhs.value.as < std::vector<hilti::Declaration> > ().push_back(yystack_[0].value.as < hilti::Declaration > ()); }
#line 3468 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 185: // struct_fields: %empty
#line 645 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::vector<Declaration>{}; }
#line 3474 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 186: // struct_field: type local_id opt_attributes ';'
#line 647 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[3].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 3480 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 187: // struct_field: func_flavor opt_func_cc func_result function_id '(' opt_func_params ')' opt_attributes ';'
#line 648 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                                                           {
                                                   auto ftype = hilti::type::Function(std::move(yystack_[6].value.as < hilti::type::function::Result > ()), std::move(yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > ()), yystack_[8].value.as < hilti::type::function::Flavor > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[5].value.as < hilti::ID > ()), yystack_[7].value.as < hilti::function::CallingConvention > (), std::move(ftype), yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                   }
#line 3489 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 188: // struct_field: func_flavor opt_func_cc func_result function_id '(' opt_func_params ')' opt_attributes braced_block
#line 652 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                                                                    {
                                                   auto ftype = hilti::type::Function(std::move(yystack_[6].value.as < hilti::type::function::Result > ()), std::move(yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > ()), yystack_[8].value.as < hilti::type::function::Flavor > (), __loc__);
                                                   auto func = hilti::Function(yystack_[5].value.as < hilti::ID > (), std::move(ftype), std::move(yystack_[0].value.as < hilti::Statement > ()), yystack_[7].value.as < hilti::function::CallingConvention > (), {});
                                                   yylhs.value.as < hilti::Declaration > () = hilti::declaration::Field(yystack_[5].value.as < hilti::ID > (), std::move(func), yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                   }
#line 3499 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 189: // union_type: "union" opt_attributes '{' opt_union_fields '}'
#line 659 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Union(std::move(yystack_[1].value.as < std::vector<hilti::Declaration> > ()), __loc__); }
#line 3505 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 190: // opt_union_fields: union_fields
#line 661 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = yystack_[0].value.as < std::vector<hilti::Declaration> > (); }
#line 3511 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 191: // opt_union_fields: %empty
#line 662 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::vector<Declaration>(); }
#line 3517 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 192: // union_fields: union_fields ',' union_field
#line 664 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::move(yystack_[2].value.as < std::vector<hilti::Declaration> > ()); yylhs.value.as < std::vector<hilti::Declaration> > ().push_back(std::move(yystack_[0].value.as < hilti::Declaration > ())); }
#line 3523 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 193: // union_fields: union_field
#line 665 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::vector<Declaration>(); yylhs.value.as < std::vector<hilti::Declaration> > ().push_back(std::move(yystack_[0].value.as < hilti::Declaration > ())); }
#line 3529 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 194: // union_field: type local_id opt_attributes
#line 667 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[1].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Type > ()), std::move(yystack_[0].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 3535 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 195: // enum_type: "enum" '{' enum_labels '}'
#line 669 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Enum(std::move(yystack_[1].value.as < std::vector<hilti::type::enum_::Label> > ()), __loc__); }
#line 3541 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 196: // enum_type: "enum" '<' '*' '>'
#line 670 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Enum(type::Wildcard(), __loc__); }
#line 3547 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 197: // enum_labels: enum_labels ',' enum_label
#line 672 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[2].value.as < std::vector<hilti::type::enum_::Label> > ()); yylhs.value.as < std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label > ())); }
#line 3553 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 198: // enum_labels: enum_labels ','
#line 673 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[1].value.as < std::vector<hilti::type::enum_::Label> > ()); }
#line 3559 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 199: // enum_labels: enum_label
#line 674 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::enum_::Label> > () = std::vector<hilti::type::enum_::Label>(); yylhs.value.as < std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label > ())); }
#line 3565 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 200: // enum_label: local_id
#line 677 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 3571 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 201: // enum_label: local_id '=' "unsigned integer value"
#line 678 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[2].value.as < hilti::ID > ()), yystack_[0].value.as < uint64_t > (), __loc__); }
#line 3577 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 202: // expr: expr_0
#line 683 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3583 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 203: // opt_exprs: exprs
#line 686 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::move(yystack_[0].value.as < std::vector<hilti::Expression> > ()); }
#line 3589 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 204: // opt_exprs: %empty
#line 687 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<Expression>(); }
#line 3595 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 205: // exprs: exprs ',' expr
#line 689 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::move(yystack_[2].value.as < std::vector<hilti::Expression> > ()); yylhs.value.as < std::vector<hilti::Expression> > ().push_back(std::move(yystack_[0].value.as < hilti::Expression > ())); }
#line 3601 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 206: // exprs: expr
#line 690 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<Expression>{std::move(yystack_[0].value.as < hilti::Expression > ())}; }
#line 3607 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 207: // expr_0: expr_1
#line 692 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3613 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 208: // expr_1: expr_2 '=' expr_1
#line 695 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Assign(std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 3619 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 209: // expr_1: expr_2 "-=" expr_1
#line 696 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DifferenceAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3625 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 210: // expr_1: expr_2 "+=" expr_1
#line 697 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SumAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3631 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 211: // expr_1: expr_2 "*=" expr_1
#line 698 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MultipleAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3637 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 212: // expr_1: expr_2 "/=" expr_1
#line 699 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DivisionAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3643 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 213: // expr_1: expr_2 '?' expr_1 ':' expr_1
#line 700 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Ternary(std::move(yystack_[4].value.as < hilti::Expression > ()), std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 3649 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 214: // expr_1: expr_2
#line 701 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3655 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 215: // expr_2: expr_2 "||" expr_3
#line 703 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalOr(std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 3661 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 216: // expr_2: expr_3
#line 704 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3667 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 217: // expr_3: expr_3 "&&" expr_4
#line 706 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalAnd(std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 3673 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 218: // expr_3: expr_4
#line 707 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3679 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 219: // expr_4: expr_4 "==" expr_5
#line 709 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Equal, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3685 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 220: // expr_4: expr_4 "!=" expr_5
#line 710 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unequal, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3691 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 221: // expr_4: expr_5
#line 711 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3697 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 222: // expr_5: expr_5 '<' expr_6
#line 713 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Lower, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3703 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 223: // expr_5: expr_5 '>' expr_6
#line 714 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Greater, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3709 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 224: // expr_5: expr_5 ">=" expr_6
#line 715 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::GreaterEqual, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3715 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 225: // expr_5: expr_5 "<=" expr_6
#line 716 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::LowerEqual, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3721 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 226: // expr_5: expr_6
#line 717 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3727 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 227: // expr_6: expr_6 '|' expr_7
#line 719 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitOr, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3733 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 228: // expr_6: expr_7
#line 720 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3739 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 229: // expr_7: expr_7 '^' expr_8
#line 722 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitXor, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3745 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 230: // expr_7: expr_8
#line 723 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3751 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 231: // expr_8: expr_8 '&' expr_9
#line 725 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitAnd, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3757 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 232: // expr_8: expr_9
#line 726 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3763 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 233: // expr_9: expr_9 "<<" expr_a
#line 728 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftLeft, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3769 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 234: // expr_9: expr_9 ">>" expr_a
#line 729 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftRight, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3775 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 235: // expr_9: expr_a
#line 730 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3781 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 236: // expr_a: expr_a '+' expr_b
#line 732 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Sum, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3787 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 237: // expr_a: expr_a '-' expr_b
#line 733 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Difference, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3793 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 238: // expr_a: expr_b
#line 734 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3799 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 239: // expr_b: expr_b '%' expr_c
#line 736 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Modulo, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3805 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 240: // expr_b: expr_b '*' expr_c
#line 737 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Multiple, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3811 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 241: // expr_b: expr_b '/' expr_c
#line 738 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Division, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3817 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 242: // expr_b: expr_b "**" expr_c
#line 739 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Power, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3823 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 243: // expr_b: expr_c
#line 740 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3829 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 244: // expr_c: '!' expr_c
#line 742 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalNot(std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 3835 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 245: // expr_c: '*' expr_c
#line 743 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Deref, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3841 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 246: // expr_c: '~' expr_c
#line 744 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Negate, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3847 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 247: // expr_c: '|' expr_c '|'
#line 745 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Size, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 3853 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 248: // expr_c: "--" expr_c
#line 746 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPrefix, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3859 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 249: // expr_c: "++" expr_c
#line 747 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPrefix, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3865 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 250: // expr_c: expr_d
#line 748 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3871 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 251: // expr_d: expr_d '(' opt_exprs ')'
#line 750 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Call, {std::move(yystack_[3].value.as < hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 3877 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 252: // expr_d: expr_d '.' member_expr
#line 751 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Member, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3883 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 253: // expr_d: expr_d '.' member_expr '(' opt_exprs ')'
#line 752 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                         { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MemberCall, {std::move(yystack_[5].value.as < hilti::Expression > ()), std::move(yystack_[3].value.as < hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 3889 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 254: // expr_d: expr_d '[' expr ']'
#line 753 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Index, {std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 3895 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 255: // expr_d: expr_d "?." member_expr
#line 754 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::HasMember, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3901 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 256: // expr_d: expr_d "in" expr_d
#line 755 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3907 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 257: // expr_d: expr_d "!in" expr_d
#line 756 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalNot(hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__)); }
#line 3913 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 258: // expr_d: expr_d "--"
#line 757 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPostfix, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 3919 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 259: // expr_d: expr_d "++"
#line 758 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPostfix, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 3925 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 260: // expr_d: expr_d ".?" member_expr
#line 759 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::TryMember, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3931 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 261: // expr_d: expr_e
#line 760 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3937 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 262: // expr_e: "begin" '(' expr ')'
#line 762 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Begin, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 3943 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 263: // expr_e: "cast" type_param_begin type type_param_end '(' expr ')'
#line 763 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Cast, {std::move(yystack_[1].value.as < hilti::Expression > ()), hilti::expression::Type_(std::move(yystack_[4].value.as < hilti::Type > ()))}, __loc__); }
#line 3949 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 264: // expr_e: "end" '(' expr ')'
#line 764 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::End, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 3955 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 265: // expr_e: "move" '(' expr ')'
#line 765 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Move(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 3961 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 266: // expr_e: "pack" tuple_expr
#line 766 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                  { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Pack, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3967 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 267: // expr_e: "unpack" type_param_begin type type_param_end tuple_expr
#line 767 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unpack, {hilti::expression::Type_(std::move(yystack_[2].value.as < hilti::Type > ())), std::move(yystack_[0].value.as < hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Bool(false), __loc__)}, __loc__); }
#line 3973 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 268: // expr_e: "new" expr
#line 768 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {std::move(yystack_[0].value.as < hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 3979 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 269: // expr_e: "new" type
#line 769 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::Type_(std::move(yystack_[0].value.as < hilti::Type > ())), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 3985 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 270: // expr_e: "new" type '(' opt_exprs ')'
#line 770 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::Type_(std::move(yystack_[3].value.as < hilti::Type > ())), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 3991 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 271: // expr_e: "typeinfo" '(' expr ')'
#line 771 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::TypeInfo(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 3997 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 272: // expr_e: "typeinfo" '(' base_type ')'
#line 772 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::TypeInfo(expression::Type_(std::move(yystack_[1].value.as < hilti::Type > ())), __loc__); }
#line 4003 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 273: // expr_e: expr_f
#line 773 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4009 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 274: // expr_f: ctor
#line 775 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Ctor(std::move(yystack_[0].value.as < hilti::Ctor > ()), __loc__); }
#line 4015 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 275: // expr_f: ctor_expr
#line 776 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4021 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 276: // expr_f: '-' expr_f
#line 777 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SignNeg, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4027 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 277: // expr_f: '[' expr "for" local_id "in" expr ']'
#line 779 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[1].value.as < hilti::Expression > ()), std::move(yystack_[5].value.as < hilti::Expression > ()), std::move(yystack_[3].value.as < hilti::ID > ()), {},  __loc__); }
#line 4033 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 278: // expr_f: '[' expr "for" local_id "in" expr "if" expr ']'
#line 781 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[7].value.as < hilti::Expression > ()), std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[1].value.as < hilti::Expression > ()),  __loc__); }
#line 4039 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 279: // expr_f: expr_g
#line 782 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4045 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 280: // expr_g: '(' expr ')'
#line 784 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Grouping(std::move(yystack_[1].value.as < hilti::Expression > ())); }
#line 4051 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 281: // expr_g: scoped_id
#line 785 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedID(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4057 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 282: // expr_g: "scope"
#line 786 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Keyword(hilti::expression::keyword::Kind::Scope, __loc__); }
#line 4063 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 283: // member_expr: local_id
#line 789 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Member(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4069 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 284: // member_expr: "error"
#line 790 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Member(ID("error", __loc__), __loc__); }
#line 4075 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 285: // ctor: "bool value"
#line 794 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Bool(yystack_[0].value.as < bool > (), __loc__); }
#line 4081 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 286: // ctor: "bytes value"
#line 795 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Bytes(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4087 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 287: // ctor: "string value"
#line 796 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::String(yystack_[0].value.as < std::string > (), __loc__); }
#line 4093 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 288: // ctor: "unsigned integer value"
#line 797 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__); }
#line 4099 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 289: // ctor: '+' "unsigned integer value"
#line 798 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { if ( yystack_[0].value.as < uint64_t > () > static_cast<uint64_t>(std::numeric_limits<int64_t>::max()) )
                                                    logger().error("integer constant out of range", __loc__.location());

                                                   yylhs.value.as < hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__);
                                                 }
#line 4109 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 290: // ctor: "real value"
#line 803 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Real(yystack_[0].value.as < double > (), __loc__); }
#line 4115 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 291: // ctor: '+' "real value"
#line 804 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Real(yystack_[0].value.as < double > (), __loc__);; }
#line 4121 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 292: // ctor: "Null"
#line 805 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Null(__loc__); }
#line 4127 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 293: // ctor: "address value"
#line 807 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Address(hilti::ctor::Address::Value(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4133 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 294: // ctor: "address value" '/' "unsigned integer value"
#line 808 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Network(hilti::ctor::Network::Value(yystack_[2].value.as < std::string > (), yystack_[0].value.as < uint64_t > ()), __loc__); }
#line 4139 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 295: // ctor: "port value"
#line 809 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Port(hilti::ctor::Port::Value(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4145 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 296: // ctor: "optional" '(' expr ')'
#line 814 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Optional(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 4151 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 297: // ctor: "default" type_param_begin type type_param_end '(' opt_exprs ')'
#line 816 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Default(std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4157 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 298: // ctor: list
#line 817 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4163 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 299: // ctor: map
#line 818 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4169 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 300: // ctor: regexp
#line 819 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4175 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 301: // ctor: set
#line 820 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4181 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 302: // ctor: struct_
#line 821 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4187 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 303: // ctor: tuple
#line 822 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4193 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 304: // ctor_expr: "interval" '(' expr ')'
#line 825 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("interval", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4199 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 305: // ctor_expr: "interval_ns" '(' expr ')'
#line 826 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("interval_ns", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4205 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 306: // ctor_expr: "time" '(' expr ')'
#line 827 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("time", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4211 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 307: // ctor_expr: "time_ns" '(' expr ')'
#line 828 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("time_ns", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4217 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 308: // ctor_expr: "stream" '(' expr ')'
#line 829 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("stream", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4223 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 309: // ctor_expr: "error" '(' expr ')'
#line 830 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("error", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4229 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 310: // ctor_expr: "int8" '(' expr ')'
#line 831 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("int8", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4235 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 311: // ctor_expr: "int16" '(' expr ')'
#line 832 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("int16", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4241 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 312: // ctor_expr: "int32" '(' expr ')'
#line 833 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("int32", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4247 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 313: // ctor_expr: "int64" '(' expr ')'
#line 834 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("int64", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4253 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 314: // ctor_expr: "uint8" '(' expr ')'
#line 835 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("uint8", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4259 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 315: // ctor_expr: "uint16" '(' expr ')'
#line 836 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("uint16", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4265 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 316: // ctor_expr: "uint32" '(' expr ')'
#line 837 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("uint32", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4271 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 317: // ctor_expr: "uint64" '(' expr ')'
#line 838 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("uint64", { std::move(yystack_[1].value.as < hilti::Expression > ()) }, __loc__); }
#line 4277 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 318: // ctor_expr: "port" '(' expr ',' expr ')'
#line 839 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::namedCtor("port", {std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 4283 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 319: // tuple: '(' opt_tuple_elems1 ')'
#line 842 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4289 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 320: // opt_tuple_elems1: tuple_elem
#line 845 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[0].value.as < hilti::Expression > ())}; }
#line 4295 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 321: // opt_tuple_elems1: tuple_elem ',' opt_tuple_elems2
#line 846 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as < hilti::Expression > ())}; yylhs.value.as < std::vector<hilti::Expression> > ().insert(yylhs.value.as < std::vector<hilti::Expression> > ().end(), yystack_[0].value.as < std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as < std::vector<hilti::Expression> > ().end()); }
#line 4301 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 322: // opt_tuple_elems1: %empty
#line 847 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 4307 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 323: // opt_tuple_elems2: tuple_elem
#line 850 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{ std::move(yystack_[0].value.as < hilti::Expression > ())}; }
#line 4313 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 324: // opt_tuple_elems2: tuple_elem ',' opt_tuple_elems2
#line 851 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as < hilti::Expression > ())}; yylhs.value.as < std::vector<hilti::Expression> > ().insert(yylhs.value.as < std::vector<hilti::Expression> > ().end(), yystack_[0].value.as < std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as < std::vector<hilti::Expression> > ().end()); }
#line 4319 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 325: // opt_tuple_elems2: %empty
#line 852 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 4325 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 326: // tuple_elem: expr
#line 855 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4331 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 327: // tuple_expr: tuple
#line 858 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Ctor(std::move(yystack_[0].value.as < hilti::Ctor > ()), __loc__); }
#line 4337 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 328: // list: '[' opt_exprs ']'
#line 860 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4343 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 329: // list: "list" '(' opt_exprs ')'
#line 861 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4349 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 330: // list: "list" type_param_begin type type_param_end '(' opt_tuple_elems1 ')'
#line 863 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4355 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 331: // list: "vector" '(' opt_exprs ')'
#line 864 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4361 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 332: // list: "vector" type_param_begin type type_param_end '(' opt_tuple_elems1 ')'
#line 866 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4367 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 333: // set: "set" '(' opt_exprs ')'
#line 868 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4373 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 334: // set: "set" type_param_begin type type_param_end '(' opt_tuple_elems1 ')'
#line 870 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4379 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 335: // map: "map" '(' opt_map_elems ')'
#line 872 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[1].value.as < std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 4385 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 336: // map: "map" type_param_begin type ',' type type_param_end '(' opt_map_elems ')'
#line 874 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[6].value.as < hilti::Type > ()), std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 4391 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 337: // struct_: '[' struct_elems ']'
#line 876 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                             { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Struct(std::move(yystack_[1].value.as < std::vector<hilti::ctor::struct_::Field> > ()), __loc__); }
#line 4397 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 338: // struct_elems: struct_elems ',' struct_elem
#line 878 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::struct_::Field> > () = std::move(yystack_[2].value.as < std::vector<hilti::ctor::struct_::Field> > ()); yylhs.value.as < std::vector<hilti::ctor::struct_::Field> > ().push_back(yystack_[0].value.as < hilti::ctor::struct_::Field > ()); }
#line 4403 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 339: // struct_elems: struct_elem
#line 879 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::struct_::Field> > () = std::vector<hilti::ctor::struct_::Field>{ std::move(yystack_[0].value.as < hilti::ctor::struct_::Field > ()) }; }
#line 4409 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 340: // struct_elem: '$' local_id '=' expr
#line 881 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ctor::struct_::Field > () = hilti::ctor::struct_::Field(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < hilti::Expression > ())); }
#line 4415 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 341: // regexp: re_patterns opt_attributes
#line 883 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::RegExp(std::move(yystack_[1].value.as < std::vector<std::string> > ()), std::move(yystack_[0].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 4421 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 342: // re_patterns: re_patterns '|' re_pattern_constant
#line 886 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<std::string> > () = yystack_[2].value.as < std::vector<std::string> > (); yylhs.value.as < std::vector<std::string> > ().push_back(std::move(yystack_[0].value.as < std::string > ())); }
#line 4427 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 343: // re_patterns: re_pattern_constant
#line 887 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<std::string> > () = std::vector<std::string>{std::move(yystack_[0].value.as < std::string > ())}; }
#line 4433 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 344: // $@3: %empty
#line 890 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                    { driver->enablePatternMode(); }
#line 4439 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 345: // $@4: %empty
#line 890 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                             { driver->disablePatternMode(); }
#line 4445 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 346: // re_pattern_constant: '/' $@3 "regular expression value" $@4 '/'
#line 891 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::string > () = std::move(yystack_[2].value.as < std::string > ()); }
#line 4451 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 347: // opt_map_elems: map_elems
#line 893 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[0].value.as < std::vector<hilti::ctor::map::Element> > ()); }
#line 4457 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 348: // opt_map_elems: %empty
#line 894 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); }
#line 4463 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 349: // map_elems: map_elems ',' map_elem
#line 896 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[2].value.as < std::vector<hilti::ctor::map::Element> > ()); yylhs.value.as < std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element > ())); }
#line 4469 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 350: // map_elems: map_elem
#line 897 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); yylhs.value.as < std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element > ())); }
#line 4475 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 351: // map_elem: expr ':' expr
#line 899 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ctor::map::Element > () = hilti::ctor::map::Element(yystack_[2].value.as < hilti::Expression > (), yystack_[0].value.as < hilti::Expression > (), __loc__); }
#line 4481 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 352: // attribute: "attribute"
#line 902 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < hilti::Attribute > () = hilti::Attribute(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4487 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 353: // attribute: "attribute" '=' expr
#line 903 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < hilti::Attribute > () = hilti::Attribute(std::move(yystack_[2].value.as < std::string > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 4493 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 354: // opt_attributes: opt_attributes attribute
#line 906 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < std::optional<hilti::AttributeSet> > () = hilti::AttributeSet::add(yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), yystack_[0].value.as < hilti::Attribute > ()); }
#line 4499 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 355: // opt_attributes: %empty
#line 907 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < std::optional<hilti::AttributeSet> > () = {}; }
#line 4505 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;


#line 4509 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -735;

  const short Parser::yytable_ninf_ = -323;

  const short
  Parser::yypact_[] =
  {
     -21,    46,    96,  -735,   -46,  -735,  -735,  1940,  -735,    80,
    -735,  -735,   -58,  -735,  -735,  -735,  -735,  3461,  3461,  3461,
     -25,   -16,     7,  -735,    33,   142,     7,  3461,    44,    54,
      59,    63,    46,  -735,    67,    71,    82,    94,   116,   119,
     -85,  5056,    28,   225,  3461,   136,  1771,   138,   140,  3461,
     150,  -735,  -735,  -735,  2954,  -735,    34,   159,   164,   165,
     166,  3123,  2278,   169,   176,   178,   180,   188,     7,  3461,
      37,   190,    76,  -735,  3461,  3461,  3461,   270,  3772,  -735,
    3461,  3461,  1093,  -735,  -735,  -735,  1264,  1433,  -735,  -735,
    -735,  -735,  -735,    -4,  -735,  -735,   172,  -735,  -735,  -735,
      20,   322,   -10,   -14,   -39,   183,   184,   171,   131,   -36,
    -735,     8,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,   187,  -735,  3461,  -735,   334,   198,    -5,
      21,  3461,  -735,  -735,  5160,  -735,     0,  5160,   199,  3461,
    3461,    46,  3292,   -26,  3461,  3461,  3461,  3461,  3461,  3461,
    3461,  5160,  -735,  -735,   350,  -735,  -735,  -735,   -33,  -735,
     201,  -735,     7,  -735,     7,     7,   202,     7,     7,  -735,
    -735,     7,  -735,     7,  -735,     7,     7,  -735,  -735,   205,
    -735,     7,     7,  -735,     7,     7,  -735,     7,     7,   203,
    -735,   297,  -735,  -735,  -735,    46,  -735,  -735,  -735,  -735,
    -735,  3461,  5160,  -735,  -735,  -735,  5160,  -735,  3461,  -735,
     206,   210,   -85,    28,    43,   212,    34,   214,   215,    37,
    3851,   216,  -735,  3461,  3461,  -735,  -735,  -735,  3461,  -735,
     218,  3461,  5160,  3461,  3292,  3461,  3461,  -735,   219,  2447,
    -735,  -735,   -31,   337,  -735,  -735,  2109,  3461,  3461,  3461,
    3461,  5160,   221,  3461,  5160,  3292,  -735,   222,   224,   220,
    -735,   223,  -735,  -735,  -735,   369,  -735,  -735,    46,   320,
     211,   227,   -95,  -735,  5160,   225,  5264,   225,   294,  -735,
    3461,  3461,  3461,  3461,  3461,  3461,  3461,  3461,  3461,  3461,
    3461,  3461,  3461,  3461,  3461,  3461,  3461,  3461,  3461,  3461,
    3461,  3461,  3461,  3461,  3461,    48,  3630,  -735,  3630,  -735,
      48,  3461,    48,  3461,   226,   378,   234,  -735,  -735,  -735,
    3461,  -735,  3461,   233,   229,   237,   225,   229,  -735,   236,
     238,   321,  5368,   -35,   240,  -735,  -735,   243,   244,   246,
     247,   248,   249,  -735,   250,   229,   254,    46,   251,  5160,
      18,  5160,  5160,   397,  4016,  4120,  5160,  4224,  5160,  4328,
     -30,   258,  4432,    19,    23,  4536,  5160,  4640,  4744,  3461,
     256,  -735,    66,   257,   260,   255,  -735,   261,    41,  -735,
     263,  4016,  4120,  4328,  4536,  3461,   264,  -735,   267,  -735,
     265,   229,   269,   271,   272,   273,   275,  -735,   262,  2616,
    -735,  2785,   389,  -735,   276,   277,   278,   279,   282,   284,
     229,  -735,   287,   229,   110,   295,  -735,  -735,  3461,  -735,
    -735,   300,    46,  -735,  3461,   285,  -735,   301,   294,  -735,
    5160,   296,   308,   294,  -735,  5160,   310,  -735,  -735,   426,
    -735,  -735,  -735,   306,     1,    24,    30,   302,   303,   304,
     305,   311,   312,   185,   141,   143,    36,    42,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,   100,   157,  -735,   314,   323,
     307,  -735,   326,  -735,  -735,   328,   329,  -735,  -735,   325,
    -735,  5160,   330,  -735,  -735,  3461,   471,    46,  3461,  2278,
    2278,   335,   476,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
     338,  3461,   339,    50,  -735,   333,  -735,   229,   229,   229,
     229,   342,   229,   229,   229,   344,   229,   229,   229,   229,
     229,   229,  -735,  -735,   343,   345,  -735,  5160,  -735,   229,
     332,  -735,    51,  -735,   229,   229,  4848,   229,   229,   229,
     229,   229,   229,   229,   341,   -30,  3461,  3461,   349,  3461,
    -735,  3461,  5160,  -735,  -735,  -735,  -735,  -735,   351,  -735,
     229,   347,   229,   229,   352,  -735,  3461,  -735,   354,  -735,
     356,   359,  -735,  -735,  -735,  -735,  1602,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,   140,  -735,   357,  3461,  2278,
    2278,  -735,   348,   327,  3461,   439,  -735,  -735,  3461,   361,
      41,   362,  3461,    89,    41,  5160,  3461,  -735,  3461,  -735,
    3461,  -735,  -735,  3461,    41,  3461,   360,   364,   366,   370,
     470,   475,  -735,  -735,  3461,   374,   512,  -735,    46,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  5160,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,    13,    46,  4952,  -735,
    5160,  5160,  -735,  -735,  -735,    46,   379,   373,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,   376,   380,   377,
    -735,  -735,  -735,   229,   -30,   381,  5160,   382,   383,  -735,
     385,  3461,    32,    32,    46,  -735,  3461,   386,   483,   487,
    3461,  -735,  -735,  3461,   390,  3461,   388,  3461,   391,  3461,
     392,   393,  -735,  -735,   394,  -735,   395,   398,   399,  2278,
    3461,  3461,  2278,  2278,  -735,  -735,  -735,   400,  -735,  -735,
    -735,   229,  -735,   396,  -735,    75,    46,  -735,  -735,  -735,
    -735,  -735,  5160,   521,  -735,  -735,   402,   404,   229,  -735,
     406,  3461,   407,   412,    32,  -735,   414,   411,   413,  2278,
    -735,  -735,  -735,   -29,  -735,   416,   -30,   418,  -735,   419,
    -735,   -30,    16,  -735,  -735,   -30,  -735,  -735,  -735,  -735,
     502,  -735,  -735,  -735,  3461,  -735,  5160,  -735,   559,  -735,
    5160,  3461,  -735,   420,  -735,   158,  2278,  -735,  -735,  -735,
    2278,  -735,   522,  3461,  -735,  -735,   421,  -735,  -735,   424,
    -735,   425,  -735,  -735,   559,    35,    17,  -735,   427,    25,
    2278,  -735,  -735,  -735,   410,  -735,  -735,  -735,   430,  -735,
    -735,  -735,  -735,  -735,    25,    25,   559,   -30,  -735,  -735,
     431,  -735,    15,  -735,  -735
  };

  const short
  Parser::yydefact_[] =
  {
       0,     0,     0,     3,     0,     1,    11,    45,     5,     0,
     287,   286,   293,   295,   290,   288,   285,     0,     0,     0,
       0,     0,     0,   292,     0,    45,     0,     0,     0,     0,
       0,     0,     0,    43,     0,     0,     0,     0,     0,     0,
       0,    56,     0,    61,     0,     0,    56,     0,     0,     0,
       0,    44,    42,    41,     0,   282,     0,     0,     0,     0,
       0,     0,    45,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,   322,     0,     0,     0,     0,   344,
       0,     0,   204,     4,   281,     9,    12,    13,   118,    14,
      15,    16,    17,     0,    10,    81,     0,   121,   202,   207,
     214,   216,   218,   221,   226,   228,   230,   232,   235,   238,
     243,   250,   261,   273,   279,   274,   275,   303,   298,   301,
     299,   302,   300,   355,   343,     0,    39,     0,     0,     0,
       0,     0,    87,   171,    56,    88,    56,    56,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     204,    56,   123,   122,     0,   125,   126,   131,     0,   127,
     160,    58,     0,   128,     0,     0,     0,     0,     0,    57,
     129,     0,   130,     0,   132,     0,     0,   133,   134,   183,
     135,     0,     0,   355,     0,     0,   136,     0,     0,     4,
     170,     0,    55,   173,   168,     0,   169,   163,   164,   165,
     166,   348,    56,    59,    60,    35,    56,   248,     0,   124,
     127,   128,     0,     0,     0,   130,     0,   133,   135,     0,
     170,   269,   268,     0,   322,   327,   266,   249,     0,    82,
       0,   204,    56,     0,     0,     0,     0,    85,     0,    45,
     119,   120,     0,     0,    73,    74,     0,     0,     0,     0,
       0,    56,     0,   204,    56,     0,    86,   326,     0,   320,
     245,     0,   291,   289,   276,     0,   244,   246,     0,   206,
       0,   203,     0,   339,    56,    61,    56,    61,     0,    80,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   258,     0,   259,
       0,   204,     0,     0,     0,   341,     0,   294,   103,    99,
       0,   101,     0,     0,     0,     0,    61,     0,   104,     0,
       0,     0,    56,     0,     0,     6,    37,     0,     0,     0,
       0,     0,     0,   206,     0,     0,     0,     0,     0,    56,
       0,    56,    56,     0,    56,    56,    56,    56,    56,    56,
      70,     0,    56,     0,     0,    56,    56,    56,    56,     0,
       0,   167,    32,     0,     0,   347,   350,     0,     0,    67,
       0,    56,    56,    56,    56,   204,     0,   326,     0,    83,
       0,     0,     0,     0,     0,     0,     0,    84,     0,    45,
      79,    45,    98,   115,     0,     0,     0,     0,     0,     0,
       0,   105,     0,     0,     0,     0,   280,   319,   325,   247,
     345,     0,     0,   328,     0,     0,   337,   170,     0,    33,
      56,     0,   170,     0,    34,    56,     0,   212,   209,   215,
     210,   211,   208,     0,   217,   219,   220,   224,   225,   222,
     223,   227,   229,   231,   233,   234,   236,   237,   242,   240,
     239,   241,   284,   283,   255,   256,   257,   260,     0,   252,
       0,   342,   352,   354,    40,     0,     0,   262,   172,     0,
      36,    56,     0,   264,   309,     0,     0,     0,     0,    45,
      45,     0,     0,   311,   312,   313,   310,   304,   305,   329,
       0,     0,   200,     0,   199,     0,   161,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    68,    69,     0,    62,    65,    56,   185,     0,
       4,   179,     0,   178,     0,     0,    56,     0,     0,     0,
       0,     0,     0,     0,     0,    70,     0,   204,     0,     0,
     335,     0,    56,    49,    50,    47,    46,    48,     0,   265,
       0,     0,     0,     0,     0,   296,     0,   333,     0,   308,
       0,     0,   306,   307,    75,    78,    56,   117,   114,   272,
     271,   315,   316,   317,   314,     0,   331,     0,     0,    45,
      45,   321,   323,     0,     0,     0,   205,   338,     0,     0,
       0,     0,     0,    32,     0,    56,     0,   251,   204,   254,
       0,   100,   102,     0,     0,   204,     0,     0,     0,     0,
     107,   107,    38,     7,   322,     0,     0,   195,   198,   196,
     137,   138,   144,   145,   162,   152,   153,   158,    56,   141,
     147,   146,   142,   156,   157,   182,    70,     0,    56,   175,
      56,    56,   176,   139,   140,     0,     0,   190,   193,   154,
     155,   143,   149,   148,   151,   150,    21,     0,     0,     0,
      22,   351,   349,     0,    70,   153,    56,   157,   155,   270,
       0,   322,   109,   109,     0,   267,   322,     0,   107,   107,
     325,   346,   340,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   355,   213,     0,   353,     0,     0,     0,    45,
       0,     0,    45,    45,    90,    89,     8,     0,    24,   201,
     197,     0,    64,    72,   181,    61,     0,   184,   180,   177,
     355,   189,    56,     0,    23,    31,     0,     0,     0,   318,
       0,     0,     0,     0,   108,   111,     0,     0,     0,    45,
      94,    93,   324,     0,    19,     0,    70,     0,    27,     0,
      28,    70,     0,   253,   263,    70,   297,    95,    26,    25,
     107,   106,   330,   159,     0,   355,    56,   355,   194,   192,
      56,   348,   355,   159,   334,     0,    45,    97,   110,    96,
      45,   332,   107,     0,   277,    20,     0,    30,    29,     0,
      18,     0,    91,    71,    66,     0,     0,   174,     0,     0,
      45,   113,   116,    92,     0,   355,   355,   355,     0,   186,
     336,    52,   112,   278,     0,     0,    54,    70,    51,    53,
       0,   355,     0,   187,   188
  };

  const short
  Parser::yypgoto_[] =
  {
    -735,  -735,    -1,    88,  -735,  -735,  -735,  -735,  -735,   567,
     577,  -735,  -193,  -735,   -15,  -735,  -735,  -735,    86,  -218,
    -496,  -735,  -735,  -735,  -735,   453,   -57,  -268,  -535,  -735,
     -56,  -424,  -735,  -735,  -375,  -734,  -735,  -735,    -3,  -608,
     -91,  -735,  -151,  -735,   194,  -735,  -735,  -735,   355,   443,
     870,   340,  -735,  -735,  -735,  -735,   -51,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -127,  -735,  -735,   -22,    10,  -148,
    -134,  -735,  -266,  -735,   346,   324,    27,   -12,   315,   319,
     336,    38,    26,   -28,   -54,  -735,   532,  -735,   -44,  -735,
    -735,   -47,  -599,   -74,  -413,    45,  -735,  -735,  -735,  -735,
    -735,   192,  -735,  -735,   317,  -735,  -735,  -162,  -735,    70,
    -735,  -180
  };

  const short
  Parser::yydefgoto_[] =
  {
      -1,     2,    83,    84,   491,   492,   716,     7,    85,   240,
     241,    88,   333,    89,   548,    90,    91,    92,   242,   557,
     558,   429,   205,   434,   325,   191,   192,   206,   524,   525,
     526,   378,   527,   775,   243,   244,   398,   399,   245,   714,
     743,   744,   745,   402,   403,    95,    96,   193,   194,   379,
     356,   479,   371,   196,   197,   532,   533,   198,   361,   648,
     727,   199,   656,   657,   658,   200,   503,   504,    97,   270,
     271,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   464,   115,
     116,   117,   258,   591,   259,   226,   118,   119,   120,   121,
     272,   273,   122,   123,   124,   265,   593,   374,   375,   376,
     473,   315
  };

  const short
  Parser::yytable_[] =
  {
       4,   225,   344,   364,    94,   592,   600,   430,   274,   435,
     667,   604,   522,   715,   437,   438,   207,   440,   441,   442,
     443,   227,   472,   472,   472,   717,   577,   128,   129,   130,
     472,   143,   472,   507,   534,   274,   335,   138,     3,   793,
     189,   393,   523,   288,     3,   553,   554,   260,   261,     3,
     290,     3,   266,   267,   288,   522,   222,   614,   481,   275,
     425,   276,   414,   277,   230,   741,   280,   161,   150,   291,
     301,   238,     1,   133,   305,   821,   742,   426,   306,   252,
     750,   751,   740,   390,   257,   523,   289,   748,   290,   169,
     828,   829,   269,    93,   290,   555,     5,   289,   834,   307,
     278,   555,   462,     6,   696,   412,   308,   291,   701,   127,
     281,   136,   309,   291,   620,   621,   347,   488,   707,   489,
     282,   302,   294,   283,   -63,   348,   336,   278,   131,   190,
     303,   304,   203,   204,   220,   316,   132,   310,   -55,   737,
     331,   323,   301,   794,   292,   293,   284,   319,   301,   329,
     330,   320,   334,   346,   337,   338,   339,   340,   341,   342,
     343,   311,   802,   468,   239,   133,   305,   833,   800,   819,
     306,   285,   536,   321,   239,   508,   535,   322,   312,   313,
     286,   201,   292,   293,   813,   135,   133,   231,   292,   293,
     253,   307,   133,   302,   372,   133,   223,   139,   308,   302,
     627,   133,   303,   304,   309,   628,   651,   140,   303,   304,
     478,   373,   141,    33,   688,   689,   142,   546,   380,   547,
     144,   796,   190,   305,   145,   190,   799,   306,   256,   310,
     801,   125,   126,   386,   387,   146,   400,   564,   388,   190,
     699,   343,   547,   392,   394,   395,   396,   147,   307,    51,
      52,    53,   465,   311,   466,   308,   405,   406,   407,   408,
     409,   309,   588,   343,   589,   415,   467,   421,   469,   148,
     312,   313,   149,   458,   459,   460,   461,   592,   447,   448,
     449,   450,   203,   204,   262,   263,   310,   297,   298,   208,
     190,   223,   830,   224,   190,   299,   300,     3,     8,     3,
       8,   297,   298,   228,   463,   299,   300,   299,   300,   463,
     311,   463,   233,   424,   810,   445,   446,   234,   235,   236,
     190,   343,   246,   470,   279,   456,   457,   312,   313,   247,
     475,   248,   476,   249,   767,   454,   455,   770,   771,   190,
     703,   250,   190,   255,   287,   295,   502,   296,   314,   317,
     318,   328,   805,     3,   369,   353,   807,   349,   360,   140,
     370,   530,   427,   148,   432,   228,   436,   233,   235,   385,
     389,   397,   401,   411,   792,   418,   416,   556,   417,   544,
     420,   422,   424,   423,   419,   472,   474,   477,   478,   480,
     483,   485,   484,    79,   490,   343,   575,   493,   494,   669,
     495,   496,   497,   498,   499,   501,   511,   528,   505,   545,
     551,   811,   574,   549,   550,   812,   552,   559,   565,   567,
     190,   595,   566,   569,   401,   570,   571,   572,   387,   573,
     579,   580,   581,   582,   596,   822,   583,   190,   584,   190,
     190,   586,   190,   190,   190,   190,   190,   190,   287,   590,
     190,   594,   598,   190,   190,   190,   190,   776,   268,   602,
     704,   605,   606,   294,   294,   294,   294,   708,   607,   190,
     190,   190,   190,   295,     3,   296,   608,   610,   613,   609,
     611,   612,   623,   615,   195,   617,   618,   622,   650,   221,
     626,   624,   629,   666,   691,   616,   634,   645,   619,   638,
     646,   670,   676,   690,   674,   682,   679,   681,   683,   693,
     686,   625,   695,   697,   709,   710,   599,   711,   190,   601,
     713,   603,   762,   190,   712,   713,   718,   719,   732,   731,
     733,   735,   734,   713,   624,   681,   686,   713,   225,   739,
     749,   756,   754,   758,   760,   780,   761,   774,   763,   764,
     778,   765,   713,   766,   772,   781,   668,   343,   782,   671,
     784,   373,   787,   786,   789,   790,   472,   791,   795,   190,
     797,   798,   713,   781,    86,   815,   680,   324,   816,   817,
     327,   820,   823,   827,    87,   831,   257,   818,   700,   326,
     722,   725,   746,   788,   345,   804,   578,   806,   687,   556,
     729,   404,   809,   556,   692,   779,   720,   785,   694,   451,
     264,   444,   698,   556,   452,   190,   752,   597,   343,   808,
     705,   672,     0,   706,   190,   343,     0,   502,   439,     0,
     685,   471,   453,     0,   387,   824,   825,   826,     0,     0,
     190,     0,     0,     0,     0,   377,   723,     0,     0,     0,
     530,   832,     0,     0,   730,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   220,     0,     0,   482,     0,     0,
       0,     0,     0,     0,     0,   391,     0,     0,     0,     0,
       0,     0,     0,   747,     0,   500,     0,     0,     0,     0,
       0,   387,     0,   190,   410,     0,   387,   413,     0,     0,
     387,     0,     0,   753,     0,   755,     0,   757,     0,   759,
       0,     0,     0,     0,     0,     0,     0,   428,     0,   433,
     768,   769,     0,     0,     0,   777,   190,     0,     0,     0,
       0,   568,     0,     0,     0,     0,   190,     0,   190,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     585,   343,     0,   587,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   190,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   487,     0,     0,     0,     0,
       0,     0,     0,     0,   803,     0,     0,     0,     0,     0,
       0,   373,   506,     0,   509,   510,     0,   513,   515,   516,
     518,   519,   521,   814,   556,   531,     0,     0,   538,   539,
     541,   543,     0,     0,     0,     0,     0,     0,     0,     0,
     190,     0,     0,     0,   560,   561,   562,   563,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   630,   631,   632,
     633,     0,   635,   636,   637,     0,   639,   640,   641,   642,
     643,   644,     0,     0,   190,     0,     0,     0,   190,   649,
       0,     0,   652,     0,   653,   654,     0,   659,   660,   661,
     662,   663,   664,   665,     0,     0,     0,     0,     0,     0,
       0,     0,   134,     0,     0,     0,   137,     0,     0,     0,
     675,     0,   677,   678,     0,     0,     0,     0,     0,     0,
     151,     0,   202,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   232,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   251,     0,
     254,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     647,     0,     0,     0,     0,     0,     0,     0,     0,   655,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   673,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   736,     0,     0,     0,     0,     0,   684,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   350,     0,   351,   352,     0,   354,   355,     0,
       0,     0,     0,   357,     0,   358,   359,     0,   702,     0,
       0,   362,   363,     0,   365,   366,     0,   367,   368,     0,
       0,   773,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   783,     0,
       0,   721,   381,   382,     0,     0,   383,     0,     0,   384,
       0,   726,     0,   728,   531,     0,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   738,
      20,     0,     0,     0,     0,     0,     0,    22,     0,     0,
       0,    23,     0,     0,     0,     0,     0,    26,     0,     0,
       0,     0,     0,     0,    28,     0,     0,    29,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    34,    35,    36,
      37,    38,    39,     0,     0,   655,     0,     0,    40,     0,
      42,     0,     0,     0,    44,     0,     0,    45,    46,     0,
       0,     0,    47,     0,     0,    48,     0,    49,    50,     0,
       0,     0,     0,     0,     0,     0,     0,    55,    56,     0,
       0,    57,     0,     0,     0,    59,    60,     0,     0,     0,
       0,     0,     0,     0,     0,    63,     0,    64,    65,    66,
      67,     0,    68,     0,    70,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    74,     0,     0,     0,
      75,     0,     0,     0,    76,     0,     0,    77,    78,     0,
      79,    80,    81,     0,    82,     0,   268,   -12,   -12,     0,
       0,     0,   -12,   -12,   -12,     0,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,     0,     0,     0,     0,     0,     0,
       0,   -12,     0,   -12,     0,     0,     0,     0,   -12,     0,
       0,     0,   -12,   -12,   -12,     0,     0,   -12,   -12,   -12,
       0,     0,     0,     0,     0,   -12,     0,     0,   -12,     0,
       0,     0,     0,     0,     0,   -12,     0,   -12,     0,   -12,
       0,   -12,   -12,   -12,     0,   -12,     0,     0,   -12,   -12,
     -12,   -12,   -12,   -12,     0,     0,     0,     0,     0,   -12,
     -12,   -12,     0,   -12,     0,   -12,     0,     0,   -12,   -12,
       0,     0,     0,   -12,     0,     0,   -12,     0,   -12,   -12,
       0,   -12,   -12,   -12,     0,     0,     0,   -12,   -12,   -12,
       0,     0,   -12,     0,     0,   -12,   -12,   -12,     0,     0,
       0,   -12,   -12,     0,     0,   -12,   -12,     0,   -12,   -12,
     -12,   -12,     0,   -12,   -12,   -12,     0,     0,   -12,     0,
       0,     0,   -12,     0,   -12,     0,     0,   -12,     0,     0,
       0,   -12,     0,     0,     0,   -12,     0,     0,   -12,   -12,
       0,   -12,   -12,   -12,     0,   -12,   -13,   -13,     0,     0,
       0,   -13,   -13,   -13,     0,   -13,   -13,   -13,   -13,   -13,
     -13,   -13,   -13,     0,     0,     0,     0,     0,     0,     0,
     -13,     0,   -13,     0,     0,     0,     0,   -13,     0,     0,
       0,   -13,   -13,   -13,     0,     0,   -13,   -13,   -13,     0,
       0,     0,     0,     0,   -13,     0,     0,   -13,     0,     0,
       0,     0,     0,     0,   -13,     0,   -13,     0,   -13,     0,
     -13,   -13,   -13,     0,   -13,     0,     0,   -13,   -13,   -13,
     -13,   -13,   -13,     0,     0,     0,     0,     0,   -13,   -13,
     -13,     0,   -13,     0,   -13,     0,     0,   -13,   -13,     0,
       0,     0,   -13,     0,     0,   -13,     0,   -13,   -13,     0,
     -13,   -13,   -13,     0,     0,     0,   -13,   -13,   -13,     0,
       0,   -13,     0,     0,   -13,   -13,   -13,     0,     0,     0,
     -13,   -13,     0,     0,   -13,   -13,     0,   -13,   -13,   -13,
     -13,     0,   -13,   -13,   -13,     0,     0,   -13,     0,     0,
       0,   -13,     0,   -13,     0,     0,   -13,     0,     0,     0,
     -13,     0,     0,     0,   -13,     0,     0,   -13,   -13,     0,
     -13,   -13,   -13,     0,   -13,     3,     8,     0,     0,     0,
       0,    10,    11,     0,    12,    13,    14,    15,    16,     0,
       0,     0,   152,     0,     0,   153,     0,   209,     0,    20,
     155,     0,   156,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,   157,     0,    28,   158,     0,   210,   160,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   161,
       0,     0,     0,     0,     0,   162,    34,    35,    36,    37,
     211,    39,     0,   164,   165,     0,   166,   212,     0,   213,
       0,   169,     0,    44,     0,     0,    45,    46,     0,   170,
       0,   214,     0,     0,    48,     0,    49,   215,     0,     0,
       0,     0,   173,   174,   175,     0,    55,   216,     0,     0,
     217,   178,   179,     0,   218,    60,     0,     0,     0,     0,
       0,     0,   181,     0,    63,   182,    64,    65,    66,    67,
     183,    68,     0,   219,   185,   186,     0,     0,   187,   188,
       0,     0,     0,     0,     0,    74,  -322,     0,     0,    75,
       0,     0,     0,    76,     0,     0,    77,    78,     0,    79,
      80,    81,     0,    82,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,     0,     0,
       0,   152,     0,     0,   153,     0,   209,     0,    20,   155,
       0,   156,     0,     0,     0,    22,     0,     0,     0,    23,
       0,     0,     0,     0,     0,    26,     0,     0,     0,     0,
     157,     0,    28,   158,     0,   210,   160,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   161,     0,
       0,     0,     0,     0,   162,    34,    35,    36,    37,   211,
      39,     0,   164,   165,     0,   166,   212,     0,   213,     0,
     169,     0,    44,     0,     0,    45,    46,     0,   170,     0,
     214,     0,     0,    48,     0,    49,   215,     0,     0,     0,
       0,   173,   174,   175,     0,    55,   216,     0,     0,   217,
     178,   179,     0,   218,    60,     0,     0,     0,     0,     0,
       0,   181,     0,    63,   182,    64,    65,    66,    67,   183,
      68,     0,   219,   185,   186,     0,     0,   187,   188,     0,
       0,     0,     0,     0,    74,     0,     0,     0,    75,     0,
       0,     0,    76,     0,     0,    77,    78,     0,    79,    80,
      81,     0,    82,     3,     8,     0,     0,     0,     9,    10,
      11,     0,    12,    13,    14,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,     0,     0,    20,     0,    21,
       0,     0,     0,     0,    22,     0,     0,     0,    23,     0,
      24,     0,     0,    25,    26,    27,     0,     0,     0,     0,
       0,    28,     0,     0,    29,     0,     0,     0,     0,     0,
       0,    30,     0,     0,     0,     0,     0,     0,    31,    32,
       0,    33,     0,     0,    34,    35,    36,    37,    38,    39,
       0,     0,     0,     0,     0,    40,    41,    42,     0,    43,
       0,    44,     0,     0,    45,    46,     0,     0,     0,    47,
       0,     0,    48,     0,    49,    50,     0,    51,    52,    53,
       0,     0,     0,    54,    55,    56,     0,     0,    57,     0,
       0,    58,    59,    60,     0,     0,     0,    61,    62,     0,
       0,     0,    63,     0,    64,    65,    66,    67,     0,    68,
      69,    70,     0,     0,    71,     0,     0,     0,    72,     0,
      73,     0,     0,    74,     0,     0,     0,    75,     0,     0,
       0,    76,     0,     0,    77,    78,     0,    79,    80,    81,
       0,    82,     3,     8,     0,     0,     0,     0,    10,    11,
       0,    12,    13,    14,    15,    16,     0,     0,     0,   152,
       0,     0,   153,     0,   209,     0,    20,   155,     0,   156,
       0,     0,     0,    22,     0,     0,     0,    23,     0,     0,
       0,     0,     0,    26,     0,     0,     0,     0,   157,     0,
      28,   158,     0,   210,   160,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   162,    34,    35,    36,    37,   211,    39,     0,
     164,   165,     0,   166,   212,     0,   213,     0,     0,     0,
      44,     0,     0,    45,    46,     0,   170,     0,   214,     0,
       0,    48,     0,    49,   215,     0,     0,     0,     0,   173,
     174,   175,     0,    55,   216,     0,     0,   217,   178,   179,
       0,   218,    60,     0,     0,     0,     0,     0,     0,   181,
       0,    63,   182,    64,    65,    66,    67,   183,    68,     0,
     219,   185,   186,     0,     0,   187,   188,     0,     0,     0,
       0,     0,    74,     0,     0,     0,    75,     0,     0,     0,
      76,     0,     0,    77,    78,     0,    79,    80,    81,     0,
      82,     3,     8,     0,     0,     0,     0,    10,    11,     0,
      12,    13,    14,    15,    16,    17,    18,    19,     0,     0,
       0,     0,     0,     0,     0,    20,     0,    21,     0,     0,
       0,     0,    22,     0,     0,     0,    23,     0,    24,     0,
       0,     0,    26,    27,     0,     0,     0,     0,     0,    28,
       0,     0,    29,     0,     0,     0,     0,     0,     0,    30,
       0,     0,     0,     0,     0,     0,    31,     0,     0,    33,
       0,     0,    34,    35,    36,    37,    38,    39,     0,     0,
       0,     0,     0,    40,    41,    42,     0,     0,     0,    44,
       0,     0,    45,    46,     0,     0,     0,    47,     0,     0,
      48,     0,    49,    50,     0,    51,    52,    53,     0,     0,
       0,    54,    55,    56,     0,     0,    57,     0,     0,    58,
      59,    60,     0,     0,     0,    61,    62,     0,     0,     0,
      63,     0,    64,    65,    66,    67,     0,    68,    69,    70,
       0,     0,    71,     0,     0,     0,    72,   239,     0,     0,
       0,    74,     0,     0,     0,    75,     0,     0,     0,    76,
       0,     0,    77,    78,     0,    79,    80,    81,     0,    82,
       3,     8,     0,     0,     0,     0,    10,    11,     0,    12,
      13,    14,    15,    16,    17,    18,    19,     0,     0,     0,
       0,     0,     0,     0,    20,     0,    21,     0,     0,     0,
       0,    22,     0,     0,     0,    23,     0,    24,     0,     0,
       0,    26,    27,     0,     0,     0,     0,     0,    28,     0,
       0,    29,     0,     0,     0,     0,     0,     0,    30,     0,
       0,     0,     0,     0,     0,    31,     0,     0,    33,     0,
       0,    34,    35,    36,    37,    38,    39,     0,     0,     0,
       0,     0,    40,    41,    42,     0,     0,     0,    44,     0,
       0,    45,    46,     0,     0,     0,    47,     0,     0,    48,
       0,    49,    50,     0,    51,    52,    53,     0,     0,     0,
      54,    55,    56,     0,     0,    57,     0,     0,    58,    59,
      60,     0,     0,     0,    61,    62,     0,     0,     0,    63,
       0,    64,    65,    66,    67,     0,    68,    69,    70,     0,
       0,    71,     0,     0,     0,    72,     0,   -77,     0,     0,
      74,     0,     0,     0,    75,     0,     0,     0,    76,     0,
       0,    77,    78,     0,    79,    80,    81,     0,    82,     3,
       8,     0,     0,     0,     0,    10,    11,     0,    12,    13,
      14,    15,    16,    17,    18,    19,     0,     0,     0,     0,
       0,     0,     0,    20,     0,    21,     0,     0,     0,     0,
      22,     0,     0,     0,    23,     0,    24,     0,     0,     0,
      26,    27,     0,     0,     0,     0,     0,    28,     0,     0,
      29,     0,     0,     0,     0,     0,     0,    30,     0,     0,
       0,     0,     0,     0,    31,     0,     0,    33,     0,     0,
      34,    35,    36,    37,    38,    39,     0,     0,     0,     0,
       0,    40,    41,    42,     0,     0,     0,    44,     0,     0,
      45,    46,     0,     0,     0,    47,     0,     0,    48,     0,
      49,    50,     0,    51,    52,    53,     0,     0,     0,    54,
      55,    56,     0,     0,    57,     0,     0,    58,    59,    60,
       0,     0,     0,    61,    62,     0,     0,     0,    63,     0,
      64,    65,    66,    67,     0,    68,    69,    70,     0,     0,
      71,     0,     0,     0,    72,     0,   -76,     0,     0,    74,
       0,     0,     0,    75,     0,     0,     0,    76,     0,     0,
      77,    78,     0,    79,    80,    81,     0,    82,     3,     8,
       0,     0,     0,     0,    10,    11,     0,    12,    13,    14,
      15,    16,    17,    18,    19,     0,     0,     0,     0,     0,
       0,     0,    20,     0,    21,     0,     0,     0,     0,    22,
       0,     0,     0,    23,     0,    24,     0,     0,     0,    26,
      27,     0,     0,     0,     0,     0,    28,     0,     0,    29,
       0,     0,     0,     0,     0,     0,    30,     0,     0,     0,
       0,     0,     0,    31,     0,     0,    33,     0,     0,    34,
      35,    36,    37,    38,    39,     0,     0,     0,     0,     0,
      40,    41,    42,     0,     0,     0,    44,     0,     0,    45,
      46,     0,     0,     0,    47,     0,     0,    48,     0,    49,
      50,     0,    51,    52,    53,     0,     0,     0,    54,    55,
      56,     0,     0,    57,     0,     0,    58,    59,    60,     0,
       0,     0,    61,    62,     0,     0,     0,    63,     0,    64,
      65,    66,    67,     0,    68,    69,    70,     0,     0,    71,
       0,     0,     0,    72,   239,     0,     0,     0,   576,     0,
       0,     0,    75,     0,     0,     0,    76,     0,     0,    77,
      78,     0,    79,    80,    81,     0,    82,     3,     8,     0,
       0,     0,     0,    10,    11,     0,    12,    13,    14,    15,
      16,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    20,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    26,     0,
       0,     0,     0,     0,     0,    28,     0,     0,    29,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    34,    35,
      36,    37,    38,    39,     0,     0,     0,     0,     0,    40,
       0,    42,     0,     0,     0,    44,     0,     0,    45,    46,
       0,     0,     0,    47,     0,     0,    48,     0,    49,    50,
       0,     0,     0,     0,     0,     0,     0,     0,    55,    56,
       0,     0,    57,     0,     0,     0,    59,    60,     0,     0,
       0,     0,     0,     0,     0,     0,    63,     0,    64,    65,
      66,    67,     0,    68,     0,    70,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   229,    74,     0,     0,
       0,    75,     0,     0,     0,    76,     0,     0,    77,    78,
       0,    79,    80,    81,     0,    82,     3,     8,     0,     0,
       0,     0,    10,    11,     0,    12,    13,    14,    15,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,     0,     0,     0,    22,     0,     0,
       0,    23,     0,     0,     0,     0,     0,    26,     0,     0,
       0,     0,     0,     0,    28,     0,     0,    29,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    34,    35,    36,
      37,    38,    39,     0,     0,     0,     0,     0,    40,     0,
      42,     0,     0,     0,    44,     0,     0,    45,    46,     0,
       0,     0,    47,     0,     0,    48,     0,    49,    50,     0,
       0,     0,     0,     0,     0,     0,     0,    55,    56,     0,
       0,    57,     0,     0,     0,    59,    60,     0,     0,     0,
       0,     0,     0,     0,     0,    63,     0,    64,    65,    66,
      67,     0,    68,     0,    70,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   237,    74,     0,     0,     0,
      75,     0,     0,     0,    76,     0,     0,    77,    78,     0,
      79,    80,    81,     0,    82,     3,     8,     0,     0,     0,
       0,    10,    11,     0,    12,    13,    14,    15,    16,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,     0,     0,    28,     0,     0,    29,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    34,    35,    36,    37,
      38,    39,     0,     0,     0,     0,     0,    40,   332,    42,
       0,     0,     0,    44,     0,     0,    45,    46,     0,     0,
       0,    47,     0,     0,    48,     0,    49,    50,     0,     0,
       0,     0,     0,     0,     0,     0,    55,    56,     0,     0,
      57,     0,     0,     0,    59,    60,     0,     0,     0,     0,
       0,     0,     0,     0,    63,     0,    64,    65,    66,    67,
       0,    68,     0,    70,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    74,     0,     0,     0,    75,
       0,     0,     0,    76,     0,     0,    77,    78,     0,    79,
      80,    81,     0,    82,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,     0,     0,     0,     0,    22,     0,     0,     0,    23,
       0,     0,     0,     0,     0,    26,     0,     0,     0,     0,
       0,     0,    28,     0,     0,    29,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    35,    36,    37,    38,
      39,     0,     0,     0,     0,     0,    40,     0,    42,     0,
       0,     0,    44,     0,     0,    45,    46,     0,     0,     0,
      47,     0,     0,    48,     0,    49,    50,     0,     0,     0,
       0,     0,     0,     0,     0,    55,    56,     0,     0,    57,
       0,     0,     0,    59,    60,     0,     0,     0,     0,     0,
       0,     0,     0,    63,     0,    64,    65,    66,    67,     0,
      68,     0,    70,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    74,     0,     0,     0,    75,     0,
       0,     0,    76,     0,     0,    77,    78,     0,    79,    80,
      81,     0,    82,     3,     8,     0,     0,     0,     0,    10,
      11,     0,    12,    13,    14,    15,    16,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,    23,     0,
       0,     0,     0,     0,    26,     0,     0,     0,     0,     0,
       0,    28,     0,     0,    29,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    34,    35,    36,    37,    38,    39,
       0,     0,     0,     0,     0,    40,     0,    42,     0,     0,
       0,     0,     0,     0,    45,    46,     0,     0,     0,    47,
       0,     0,    48,     0,     0,    50,     0,     0,     0,     0,
       0,     0,     0,     0,    55,    56,     0,     0,    57,     0,
       0,     0,    59,    60,     0,     0,     0,     0,     0,     0,
       0,     0,    63,     0,    64,    65,    66,    67,     0,    68,
       0,    70,     0,     0,     0,     3,     8,     0,     0,     0,
       0,    10,    11,    74,    12,    13,    14,    15,    16,     0,
       0,     0,     0,     0,    77,    78,     0,    79,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    29,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    34,    35,    36,    37,
      38,    39,     0,     0,     0,     0,     0,    40,  -170,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    47,     0,  -170,     0,     0,     0,    50,     0,     0,
       0,     0,     0,     0,     0,     0,    55,    56,     0,     0,
      57,     0,     0,     0,    59,    60,     0,  -170,     0,     0,
       0,     0,     0,     0,  -170,     0,    64,    65,    66,    67,
       0,     0,  -170,    70,     0,  -170,     0,  -170,     0,  -170,
       0,  -170,     0,     0,     0,    74,     0,     0,     0,     0,
       0,     0,     0,     0,  -170,     0,    77,    78,     0,    79,
       0,  -170,  -170,    82,     0,     0,     0,  -170,     0,  -170,
       0,  -170,     0,     0,  -170,  -170,     0,  -170,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -170,  -170,     0,
       0,     0,     0,     0,     0,     0,     0,  -170,     0,     0,
    -170,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,     3,
       8,  -170,  -170,  -170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   152,     0,     0,   153,
       0,   209,     0,     0,   155,     0,   156,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   157,     0,     0,   158,     0,
     159,   160,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,     0,     0,     0,     0,     0,   162,
       0,     0,     0,     0,   163,     0,     0,   164,   165,     0,
     166,   167,     0,   168,     0,   169,     0,     0,     0,     0,
       0,     0,     0,   170,     0,   171,     0,     0,     0,     0,
       0,   172,     0,     3,     8,     0,   173,   174,   175,     0,
       0,   176,     0,     0,   177,   178,   179,     0,   180,     0,
     152,     0,     0,   153,     0,   209,   181,     0,   155,   182,
     156,     0,     0,     0,   183,     0,     0,   184,   185,   186,
       0,     0,   187,   188,     0,     0,     0,     0,     0,   157,
       0,     0,   158,   512,   159,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
       0,     0,     0,   162,     0,     0,     0,     0,   163,     0,
       0,   164,   165,     0,   166,   167,     0,   168,     0,   169,
       0,     0,     0,     0,     0,     0,     0,   170,     0,   171,
       0,     0,     0,     0,     0,   172,     0,     3,     8,     0,
     173,   174,   175,     0,     0,   176,     0,     0,   177,   178,
     179,     0,   180,     0,   152,     0,     0,   153,     0,   209,
     181,     0,   155,   182,   156,     0,     0,     0,   183,     0,
       0,   184,   185,   186,     0,     0,   187,   188,     0,     0,
       0,     0,     0,   157,     0,     0,   158,   514,   159,   160,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,     0,     0,     0,     0,     0,   162,     0,     0,
       0,     0,   163,     0,     0,   164,   165,     0,   166,   167,
       0,   168,     0,   169,     0,     0,     0,     0,     0,     0,
       0,   170,     0,   171,     0,     0,     0,     0,     0,   172,
       0,     3,     8,     0,   173,   174,   175,     0,     0,   176,
       0,     0,   177,   178,   179,     0,   180,     0,   152,     0,
       0,   153,     0,   209,   181,     0,   155,   182,   156,     0,
       0,     0,   183,     0,     0,   184,   185,   186,     0,     0,
     187,   188,     0,     0,     0,     0,     0,   157,     0,     0,
     158,   517,   159,   160,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,     0,     0,     0,     0,
       0,   162,     0,     0,     0,     0,   163,     0,     0,   164,
     165,     0,   166,   167,     0,   168,     0,   169,     0,     0,
       0,     0,     0,     0,     0,   170,     0,   171,     0,     0,
       0,     0,     0,   172,     0,     3,     8,     0,   173,   174,
     175,     0,     0,   176,     0,     0,   177,   178,   179,     0,
     180,     0,   152,     0,     0,   153,     0,   209,   181,     0,
     155,   182,   156,     0,     0,     0,   183,     0,     0,   184,
     185,   186,     0,     0,   187,   188,     0,     0,     0,     0,
       0,   157,     0,     0,   158,   520,   159,   160,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   161,
       0,     0,     0,     0,     0,   162,     0,     0,     0,     0,
     163,     0,     0,   164,   165,     0,   166,   167,     0,   168,
       0,   169,     0,     0,     0,     0,     0,     0,     0,   170,
       0,   171,     0,     0,     0,     0,     0,   172,     0,     3,
       8,     0,   173,   174,   175,     0,     0,   176,     0,     0,
     177,   178,   179,     0,   180,     0,   152,     0,     0,   153,
       0,   209,   181,     0,   155,   182,   156,     0,     0,     0,
     183,     0,     0,   184,   185,   186,     0,     0,   187,   188,
       0,     0,     0,     0,     0,   157,     0,     0,   158,   529,
     159,   160,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,     0,     0,     0,     0,     0,   162,
       0,     0,     0,     0,   163,     0,     0,   164,   165,     0,
     166,   167,     0,   168,     0,   169,     0,     0,     0,     0,
       0,     0,     0,   170,     0,   171,     0,     0,     0,     0,
       0,   172,     0,     3,     8,     0,   173,   174,   175,     0,
       0,   176,     0,     0,   177,   178,   179,     0,   180,     0,
     152,     0,     0,   153,     0,   209,   181,     0,   155,   182,
     156,     0,     0,     0,   183,     0,     0,   184,   185,   186,
       0,     0,   187,   188,     0,     0,     0,     0,     0,   157,
       0,     0,   158,   537,   159,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
       0,     0,     0,   162,     0,     0,     0,     0,   163,     0,
       0,   164,   165,     0,   166,   167,     0,   168,     0,   169,
       0,     0,     0,     0,     0,     0,     0,   170,     0,   171,
       0,     0,     0,     0,     0,   172,     0,     3,     8,     0,
     173,   174,   175,     0,     0,   176,     0,     0,   177,   178,
     179,     0,   180,     0,   152,     0,     0,   153,     0,   209,
     181,     0,   155,   182,   156,     0,     0,     0,   183,     0,
       0,   184,   185,   186,     0,     0,   187,   188,     0,     0,
       0,     0,     0,   157,     0,     0,   158,   540,   159,   160,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,     0,     0,     0,     0,     0,   162,     0,     0,
       0,     0,   163,     0,     0,   164,   165,     0,   166,   167,
       0,   168,     0,   169,     0,     0,     0,     0,     0,     0,
       0,   170,     0,   171,     0,     0,     0,     0,     0,   172,
       0,     3,     8,     0,   173,   174,   175,     0,     0,   176,
       0,     0,   177,   178,   179,     0,   180,     0,   152,     0,
       0,   153,     0,   209,   181,     0,   155,   182,   156,     0,
       0,     0,   183,     0,     0,   184,   185,   186,     0,     0,
     187,   188,     0,     0,     0,     0,     0,   157,     0,     0,
     158,   542,   159,   160,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,     0,     0,     0,     0,
       0,   162,     0,     0,     0,     0,   163,     0,     0,   164,
     165,     0,   166,   167,     0,   168,     0,   169,     0,     0,
       0,     0,     0,     0,     0,   170,     0,   171,     0,     0,
       0,     0,     0,   172,     0,     3,     8,     0,   173,   174,
     175,     0,     0,   176,     0,     0,   177,   178,   179,     0,
     180,     0,   152,     0,     0,   153,     0,   209,   181,     0,
     155,   182,   156,     0,     0,     0,   183,     0,     0,   184,
     185,   186,     0,     0,   187,   188,     0,     0,  -191,     0,
       0,   157,     0,     0,   158,     0,   159,   160,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   161,
       0,     0,     0,     0,     0,   162,     0,     0,     0,     0,
     163,     0,     0,   164,   165,     0,   166,   167,     0,   168,
       0,   169,     0,     0,     0,     0,     0,     0,     0,   170,
       0,   171,     0,     0,     0,     0,     0,   172,     0,     3,
       8,     0,   173,   174,   175,     0,     0,   176,     0,     0,
     177,   178,   179,     0,   180,     0,   152,     0,     0,   153,
       0,   154,   181,     0,   155,   182,   156,     0,     0,     0,
     183,     0,     0,   184,   185,   186,     0,     0,   187,   188,
       0,     0,   724,     0,     0,   157,     0,     0,   158,     0,
     159,   160,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,     0,     0,     0,     0,     0,   162,
       0,     0,     0,     0,   163,     0,     0,   164,   165,     0,
     166,   167,     0,   168,     0,   169,     0,     0,     0,     0,
       0,     0,     0,   170,     0,   171,     0,     0,     0,     0,
       0,   172,     0,     3,     8,     0,   173,   174,   175,     0,
       0,   176,     0,     0,   177,   178,   179,     0,   180,     0,
     152,     0,     0,   153,     0,   209,   181,     0,   155,   182,
     156,     0,     0,     0,   183,     0,     0,   184,   185,   186,
       0,     0,   187,   188,     0,     0,     0,     0,     0,   157,
       0,     0,   158,     0,   159,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
       0,     0,     0,   162,     0,     0,     0,     0,   163,     0,
       0,   164,   165,     0,   166,   167,     0,   168,     0,   169,
       0,     0,     0,     0,     0,     0,     0,   170,     0,   171,
       0,     0,     0,     0,     0,   172,     0,     3,     8,     0,
     173,   174,   175,     0,     0,   176,     0,     0,   177,   178,
     179,     0,   180,     0,   152,     0,     0,   153,     0,   431,
     181,     0,   155,   182,   156,     0,     0,     0,   183,     0,
       0,   184,   185,   186,     0,     0,   187,   188,     0,     0,
       0,     0,     0,   157,     0,     0,   158,     0,   159,   160,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,     0,     0,     0,     0,     0,   162,     0,     0,
       0,     0,   163,     0,     0,   164,   165,     0,   166,   167,
       0,   168,     0,   169,     0,     0,     0,     0,     0,     0,
       0,   170,     0,   171,     0,     0,     0,     0,     0,   172,
       0,     3,     8,     0,   173,   174,   175,     0,     0,   176,
       0,     0,   177,   178,   179,     0,   180,     0,   152,     0,
       0,   153,     0,   486,   181,     0,   155,   182,   156,     0,
       0,     0,   183,     0,     0,   184,   185,   186,     0,     0,
     187,   188,     0,     0,     0,     0,     0,   157,     0,     0,
     158,     0,   159,   160,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,     0,     0,     0,     0,
       0,   162,     0,     0,     0,     0,   163,     0,     0,   164,
     165,     0,   166,   167,     0,   168,     0,   169,     0,     0,
       0,     0,     0,     0,     0,   170,     0,   171,     0,     0,
       0,     0,     0,   172,     0,     0,     0,     0,   173,   174,
     175,     0,     0,   176,     0,     0,   177,   178,   179,     0,
     180,     0,     0,     0,     0,     0,     0,     0,   181,     0,
       0,   182,     0,     0,     0,     0,   183,     0,     0,   184,
     185,   186,     0,     0,   187,   188
  };

  const short
  Parser::yycheck_[] =
  {
       1,    48,   150,   183,     7,   418,   430,   275,    39,   277,
     545,   435,    42,   621,   280,   281,    44,   283,   284,   285,
     286,    49,     7,     7,     7,   624,   401,    17,    18,    19,
       7,    32,     7,    15,    15,    39,    62,    27,     3,    68,
      41,   234,    72,    53,     3,     4,     5,    75,    76,     3,
      64,     3,    80,    81,    53,    42,    46,   481,   326,    63,
     155,    65,   255,    67,    54,    33,    46,    67,   153,    83,
     106,    61,    93,   158,    66,   809,    44,   172,    70,    69,
     688,   689,   681,   231,    74,    72,    96,   686,    64,    89,
     824,   825,    82,     7,    64,    60,     0,    96,   832,    91,
     131,    60,    54,   149,   600,   253,    98,    83,   604,   167,
      90,    25,   104,    83,   489,   490,   149,   152,   614,   154,
     100,   157,   161,   103,   154,   158,   152,   131,   153,    41,
     166,   167,    57,    58,    46,   125,   152,   129,    63,   674,
     141,   131,   106,   172,   158,   159,   126,   152,   106,   139,
     140,   156,   142,   154,   144,   145,   146,   147,   148,   149,
     150,   153,   770,   311,   149,   158,    66,   152,   152,   152,
      70,   151,   149,   152,   149,   157,   157,   156,   170,   171,
     160,   153,   158,   159,   792,   152,   158,   153,   158,   159,
     153,    91,   158,   157,   195,   158,   153,   153,    98,   157,
     150,   158,   166,   167,   104,   155,   155,   153,   166,   167,
     159,   201,   153,    71,   589,   590,   153,   151,   208,   153,
     153,   756,   134,    66,   153,   137,   761,    70,   152,   129,
     765,   151,   152,   223,   224,   153,   239,   385,   228,   151,
     151,   231,   153,   233,   234,   235,   236,   153,    91,   107,
     108,   109,   306,   153,   308,    98,   246,   247,   248,   249,
     250,   104,   152,   253,   154,   255,   310,   268,   312,   153,
     170,   171,   153,   301,   302,   303,   304,   690,   290,   291,
     292,   293,    57,    58,    14,    15,   129,   116,   117,   153,
     202,   153,   827,   153,   206,   164,   165,     3,     4,     3,
       4,   116,   117,   153,   305,   164,   165,   164,   165,   310,
     153,   312,   153,   155,   156,   288,   289,   153,   153,   153,
     232,   311,   153,   313,   152,   299,   300,   170,   171,   153,
     320,   153,   322,   153,   709,   297,   298,   712,   713,   251,
     606,   153,   254,   153,    22,   162,   347,   163,   161,    15,
     152,   152,   776,     3,   151,   153,   780,   156,   153,   153,
      63,   362,   274,   153,   276,   153,   278,   153,   153,   153,
     152,   152,    35,   152,   749,   155,   154,   378,   154,   369,
      11,    61,   155,   172,   161,     7,   152,   154,   159,   152,
     154,    70,   154,   167,   154,   385,   399,   154,   154,   547,
     154,   154,   154,   154,   154,   151,     9,   149,   157,   153,
     155,   786,   150,   156,   154,   790,   155,   154,   154,   154,
     332,   422,   155,   154,    35,   154,   154,   154,   418,   154,
     154,   154,   154,   154,   424,   810,   154,   349,   154,   351,
     352,   154,   354,   355,   356,   357,   358,   359,    22,   154,
     362,   151,   151,   365,   366,   367,   368,   725,   173,   151,
     608,   151,   156,   161,   161,   161,   161,   615,   154,   381,
     382,   383,   384,   162,     3,   163,   153,   151,   153,   172,
     152,   152,     6,   153,    41,   486,   487,   152,   156,    46,
     151,   153,   159,   152,   167,   485,   154,   154,   488,   155,
     155,   152,   155,   155,   153,   149,   154,   153,   149,    70,
     153,   501,   151,   151,   154,   151,   428,   151,   430,   431,
      50,   433,   702,   435,   154,    50,   152,    15,   155,   150,
     154,   154,   152,    50,   153,   153,   153,    50,   585,   154,
     154,   153,   152,   152,   152,    24,   153,   151,   154,   154,
     730,   153,    50,   154,   154,   153,   546,   547,   154,   549,
     154,   551,   150,   156,   150,   154,     7,   154,   152,   481,
     152,   152,    50,   153,     7,   154,   566,   134,   154,   154,
     137,   154,   172,   153,     7,   154,   576,   805,   603,   136,
     646,   648,   683,   744,   151,   775,   402,   777,   588,   600,
     651,   246,   782,   604,   594,   732,   628,   741,   598,   294,
      78,   287,   602,   614,   295,   527,   690,   425,   608,   781,
     610,   551,    -1,   613,   536,   615,    -1,   628,   282,    -1,
     585,   314,   296,    -1,   624,   815,   816,   817,    -1,    -1,
     552,    -1,    -1,    -1,    -1,   202,   647,    -1,    -1,    -1,
     651,   831,    -1,    -1,   655,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   576,    -1,    -1,   327,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   232,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   684,    -1,   345,    -1,    -1,    -1,    -1,
      -1,   681,    -1,   605,   251,    -1,   686,   254,    -1,    -1,
     690,    -1,    -1,   693,    -1,   695,    -1,   697,    -1,   699,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,   276,
     710,   711,    -1,    -1,    -1,   726,   638,    -1,    -1,    -1,
      -1,   391,    -1,    -1,    -1,    -1,   648,    -1,   650,   651,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     410,   741,    -1,   413,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   676,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   332,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   774,    -1,    -1,    -1,    -1,    -1,
      -1,   781,   349,    -1,   351,   352,    -1,   354,   355,   356,
     357,   358,   359,   793,   805,   362,    -1,    -1,   365,   366,
     367,   368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     732,    -1,    -1,    -1,   381,   382,   383,   384,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,   509,
     510,    -1,   512,   513,   514,    -1,   516,   517,   518,   519,
     520,   521,    -1,    -1,   776,    -1,    -1,    -1,   780,   529,
      -1,    -1,   532,    -1,   534,   535,    -1,   537,   538,   539,
     540,   541,   542,   543,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    -1,    -1,    -1,    26,    -1,    -1,    -1,
     560,    -1,   562,   563,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     527,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   536,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   552,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   673,    -1,    -1,    -1,    -1,    -1,   576,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   162,    -1,   164,   165,    -1,   167,   168,    -1,
      -1,    -1,    -1,   173,    -1,   175,   176,    -1,   605,    -1,
      -1,   181,   182,    -1,   184,   185,    -1,   187,   188,    -1,
      -1,   721,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   738,    -1,
      -1,   638,   212,   213,    -1,    -1,   216,    -1,    -1,   219,
      -1,   648,    -1,   650,   651,    -1,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   676,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      -1,    38,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    79,    -1,    -1,   732,    -1,    -1,    85,    -1,
      87,    -1,    -1,    -1,    91,    -1,    -1,    94,    95,    -1,
      -1,    -1,    99,    -1,    -1,   102,    -1,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,    -1,
      -1,   118,    -1,    -1,    -1,   122,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   132,    -1,   134,   135,   136,
     137,    -1,   139,    -1,   141,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,
     157,    -1,    -1,    -1,   161,    -1,    -1,   164,   165,    -1,
     167,   168,   169,    -1,   171,    -1,   173,     3,     4,    -1,
      -1,    -1,     8,     9,    10,    -1,    12,    13,    14,    15,
      16,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    27,    -1,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    38,    39,    40,    -1,    -1,    43,    44,    45,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    61,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,    85,
      86,    87,    -1,    89,    -1,    91,    -1,    -1,    94,    95,
      -1,    -1,    -1,    99,    -1,    -1,   102,    -1,   104,   105,
      -1,   107,   108,   109,    -1,    -1,    -1,   113,   114,   115,
      -1,    -1,   118,    -1,    -1,   121,   122,   123,    -1,    -1,
      -1,   127,   128,    -1,    -1,   131,   132,    -1,   134,   135,
     136,   137,    -1,   139,   140,   141,    -1,    -1,   144,    -1,
      -1,    -1,   148,    -1,   150,    -1,    -1,   153,    -1,    -1,
      -1,   157,    -1,    -1,    -1,   161,    -1,    -1,   164,   165,
      -1,   167,   168,   169,    -1,   171,     3,     4,    -1,    -1,
      -1,     8,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      -1,    38,    39,    40,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    61,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    71,    -1,    -1,    74,    75,    76,
      77,    78,    79,    -1,    -1,    -1,    -1,    -1,    85,    86,
      87,    -1,    89,    -1,    91,    -1,    -1,    94,    95,    -1,
      -1,    -1,    99,    -1,    -1,   102,    -1,   104,   105,    -1,
     107,   108,   109,    -1,    -1,    -1,   113,   114,   115,    -1,
      -1,   118,    -1,    -1,   121,   122,   123,    -1,    -1,    -1,
     127,   128,    -1,    -1,   131,   132,    -1,   134,   135,   136,
     137,    -1,   139,   140,   141,    -1,    -1,   144,    -1,    -1,
      -1,   148,    -1,   150,    -1,    -1,   153,    -1,    -1,    -1,
     157,    -1,    -1,    -1,   161,    -1,    -1,   164,   165,    -1,
     167,   168,   169,    -1,   171,     3,     4,    -1,    -1,    -1,
      -1,     9,    10,    -1,    12,    13,    14,    15,    16,    -1,
      -1,    -1,    20,    -1,    -1,    23,    -1,    25,    -1,    27,
      28,    -1,    30,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    49,    -1,    51,    52,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    73,    74,    75,    76,    77,
      78,    79,    -1,    81,    82,    -1,    84,    85,    -1,    87,
      -1,    89,    -1,    91,    -1,    -1,    94,    95,    -1,    97,
      -1,    99,    -1,    -1,   102,    -1,   104,   105,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,   114,   115,    -1,    -1,
     118,   119,   120,    -1,   122,   123,    -1,    -1,    -1,    -1,
      -1,    -1,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,    -1,   146,   147,
      -1,    -1,    -1,    -1,    -1,   153,   154,    -1,    -1,   157,
      -1,    -1,    -1,   161,    -1,    -1,   164,   165,    -1,   167,
     168,   169,    -1,   171,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    20,    -1,    -1,    23,    -1,    25,    -1,    27,    28,
      -1,    30,    -1,    -1,    -1,    34,    -1,    -1,    -1,    38,
      -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      49,    -1,    51,    52,    -1,    54,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    73,    74,    75,    76,    77,    78,
      79,    -1,    81,    82,    -1,    84,    85,    -1,    87,    -1,
      89,    -1,    91,    -1,    -1,    94,    95,    -1,    97,    -1,
      99,    -1,    -1,   102,    -1,   104,   105,    -1,    -1,    -1,
      -1,   110,   111,   112,    -1,   114,   115,    -1,    -1,   118,
     119,   120,    -1,   122,   123,    -1,    -1,    -1,    -1,    -1,
      -1,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,    -1,   146,   147,    -1,
      -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,   157,    -1,
      -1,    -1,   161,    -1,    -1,   164,   165,    -1,   167,   168,
     169,    -1,   171,     3,     4,    -1,    -1,    -1,     8,     9,
      10,    -1,    12,    13,    14,    15,    16,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    38,    -1,
      40,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    68,    69,
      -1,    71,    -1,    -1,    74,    75,    76,    77,    78,    79,
      -1,    -1,    -1,    -1,    -1,    85,    86,    87,    -1,    89,
      -1,    91,    -1,    -1,    94,    95,    -1,    -1,    -1,    99,
      -1,    -1,   102,    -1,   104,   105,    -1,   107,   108,   109,
      -1,    -1,    -1,   113,   114,   115,    -1,    -1,   118,    -1,
      -1,   121,   122,   123,    -1,    -1,    -1,   127,   128,    -1,
      -1,    -1,   132,    -1,   134,   135,   136,   137,    -1,   139,
     140,   141,    -1,    -1,   144,    -1,    -1,    -1,   148,    -1,
     150,    -1,    -1,   153,    -1,    -1,    -1,   157,    -1,    -1,
      -1,   161,    -1,    -1,   164,   165,    -1,   167,   168,   169,
      -1,   171,     3,     4,    -1,    -1,    -1,    -1,     9,    10,
      -1,    12,    13,    14,    15,    16,    -1,    -1,    -1,    20,
      -1,    -1,    23,    -1,    25,    -1,    27,    28,    -1,    30,
      -1,    -1,    -1,    34,    -1,    -1,    -1,    38,    -1,    -1,
      -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    49,    -1,
      51,    52,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    74,    75,    76,    77,    78,    79,    -1,
      81,    82,    -1,    84,    85,    -1,    87,    -1,    -1,    -1,
      91,    -1,    -1,    94,    95,    -1,    97,    -1,    99,    -1,
      -1,   102,    -1,   104,   105,    -1,    -1,    -1,    -1,   110,
     111,   112,    -1,   114,   115,    -1,    -1,   118,   119,   120,
      -1,   122,   123,    -1,    -1,    -1,    -1,    -1,    -1,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,    -1,   146,   147,    -1,    -1,    -1,
      -1,    -1,   153,    -1,    -1,    -1,   157,    -1,    -1,    -1,
     161,    -1,    -1,   164,   165,    -1,   167,   168,   169,    -1,
     171,     3,     4,    -1,    -1,    -1,    -1,     9,    10,    -1,
      12,    13,    14,    15,    16,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    -1,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    38,    -1,    40,    -1,
      -1,    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,
      -1,    -1,    74,    75,    76,    77,    78,    79,    -1,    -1,
      -1,    -1,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    94,    95,    -1,    -1,    -1,    99,    -1,    -1,
     102,    -1,   104,   105,    -1,   107,   108,   109,    -1,    -1,
      -1,   113,   114,   115,    -1,    -1,   118,    -1,    -1,   121,
     122,   123,    -1,    -1,    -1,   127,   128,    -1,    -1,    -1,
     132,    -1,   134,   135,   136,   137,    -1,   139,   140,   141,
      -1,    -1,   144,    -1,    -1,    -1,   148,   149,    -1,    -1,
      -1,   153,    -1,    -1,    -1,   157,    -1,    -1,    -1,   161,
      -1,    -1,   164,   165,    -1,   167,   168,   169,    -1,   171,
       3,     4,    -1,    -1,    -1,    -1,     9,    10,    -1,    12,
      13,    14,    15,    16,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    27,    -1,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    -1,    38,    -1,    40,    -1,    -1,
      -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,
      -1,    74,    75,    76,    77,    78,    79,    -1,    -1,    -1,
      -1,    -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    94,    95,    -1,    -1,    -1,    99,    -1,    -1,   102,
      -1,   104,   105,    -1,   107,   108,   109,    -1,    -1,    -1,
     113,   114,   115,    -1,    -1,   118,    -1,    -1,   121,   122,
     123,    -1,    -1,    -1,   127,   128,    -1,    -1,    -1,   132,
      -1,   134,   135,   136,   137,    -1,   139,   140,   141,    -1,
      -1,   144,    -1,    -1,    -1,   148,    -1,   150,    -1,    -1,
     153,    -1,    -1,    -1,   157,    -1,    -1,    -1,   161,    -1,
      -1,   164,   165,    -1,   167,   168,   169,    -1,   171,     3,
       4,    -1,    -1,    -1,    -1,     9,    10,    -1,    12,    13,
      14,    15,    16,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    -1,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    -1,    38,    -1,    40,    -1,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,
      74,    75,    76,    77,    78,    79,    -1,    -1,    -1,    -1,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      94,    95,    -1,    -1,    -1,    99,    -1,    -1,   102,    -1,
     104,   105,    -1,   107,   108,   109,    -1,    -1,    -1,   113,
     114,   115,    -1,    -1,   118,    -1,    -1,   121,   122,   123,
      -1,    -1,    -1,   127,   128,    -1,    -1,    -1,   132,    -1,
     134,   135,   136,   137,    -1,   139,   140,   141,    -1,    -1,
     144,    -1,    -1,    -1,   148,    -1,   150,    -1,    -1,   153,
      -1,    -1,    -1,   157,    -1,    -1,    -1,   161,    -1,    -1,
     164,   165,    -1,   167,   168,   169,    -1,   171,     3,     4,
      -1,    -1,    -1,    -1,     9,    10,    -1,    12,    13,    14,
      15,    16,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    27,    -1,    29,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    -1,    38,    -1,    40,    -1,    -1,    -1,    44,
      45,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    74,
      75,    76,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    94,
      95,    -1,    -1,    -1,    99,    -1,    -1,   102,    -1,   104,
     105,    -1,   107,   108,   109,    -1,    -1,    -1,   113,   114,
     115,    -1,    -1,   118,    -1,    -1,   121,   122,   123,    -1,
      -1,    -1,   127,   128,    -1,    -1,    -1,   132,    -1,   134,
     135,   136,   137,    -1,   139,   140,   141,    -1,    -1,   144,
      -1,    -1,    -1,   148,   149,    -1,    -1,    -1,   153,    -1,
      -1,    -1,   157,    -1,    -1,    -1,   161,    -1,    -1,   164,
     165,    -1,   167,   168,   169,    -1,   171,     3,     4,    -1,
      -1,    -1,    -1,     9,    10,    -1,    12,    13,    14,    15,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,    85,
      -1,    87,    -1,    -1,    -1,    91,    -1,    -1,    94,    95,
      -1,    -1,    -1,    99,    -1,    -1,   102,    -1,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,
      -1,    -1,   118,    -1,    -1,    -1,   122,   123,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,   134,   135,
     136,   137,    -1,   139,    -1,   141,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   152,   153,    -1,    -1,
      -1,   157,    -1,    -1,    -1,   161,    -1,    -1,   164,   165,
      -1,   167,   168,   169,    -1,   171,     3,     4,    -1,    -1,
      -1,    -1,     9,    10,    -1,    12,    13,    14,    15,    16,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      -1,    38,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    79,    -1,    -1,    -1,    -1,    -1,    85,    -1,
      87,    -1,    -1,    -1,    91,    -1,    -1,    94,    95,    -1,
      -1,    -1,    99,    -1,    -1,   102,    -1,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,    -1,
      -1,   118,    -1,    -1,    -1,   122,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   132,    -1,   134,   135,   136,
     137,    -1,   139,    -1,   141,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   152,   153,    -1,    -1,    -1,
     157,    -1,    -1,    -1,   161,    -1,    -1,   164,   165,    -1,
     167,   168,   169,    -1,   171,     3,     4,    -1,    -1,    -1,
      -1,     9,    10,    -1,    12,    13,    14,    15,    16,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    79,    -1,    -1,    -1,    -1,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    94,    95,    -1,    -1,
      -1,    99,    -1,    -1,   102,    -1,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,   115,    -1,    -1,
     118,    -1,    -1,    -1,   122,   123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   132,    -1,   134,   135,   136,   137,
      -1,   139,    -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,   157,
      -1,    -1,    -1,   161,    -1,    -1,   164,   165,    -1,   167,
     168,   169,    -1,   171,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    38,
      -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      79,    -1,    -1,    -1,    -1,    -1,    85,    -1,    87,    -1,
      -1,    -1,    91,    -1,    -1,    94,    95,    -1,    -1,    -1,
      99,    -1,    -1,   102,    -1,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,   115,    -1,    -1,   118,
      -1,    -1,    -1,   122,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   132,    -1,   134,   135,   136,   137,    -1,
     139,    -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,   157,    -1,
      -1,    -1,   161,    -1,    -1,   164,   165,    -1,   167,   168,
     169,    -1,   171,     3,     4,    -1,    -1,    -1,    -1,     9,
      10,    -1,    12,    13,    14,    15,    16,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    38,    -1,
      -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    74,    75,    76,    77,    78,    79,
      -1,    -1,    -1,    -1,    -1,    85,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    -1,    -1,    -1,    99,
      -1,    -1,   102,    -1,    -1,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,   115,    -1,    -1,   118,    -1,
      -1,    -1,   122,   123,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   132,    -1,   134,   135,   136,   137,    -1,   139,
      -1,   141,    -1,    -1,    -1,     3,     4,    -1,    -1,    -1,
      -1,     9,    10,   153,    12,    13,    14,    15,    16,    -1,
      -1,    -1,    -1,    -1,   164,   165,    -1,   167,    -1,    -1,
      -1,   171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    79,    -1,    -1,    -1,    -1,    -1,    85,     7,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    99,    -1,    22,    -1,    -1,    -1,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,   115,    -1,    -1,
     118,    -1,    -1,    -1,   122,   123,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    -1,    53,    -1,   134,   135,   136,   137,
      -1,    -1,    61,   141,    -1,    64,    -1,    66,    -1,    68,
      -1,    70,    -1,    -1,    -1,   153,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    83,    -1,   164,   165,    -1,   167,
      -1,    90,    91,   171,    -1,    -1,    -1,    96,    -1,    98,
      -1,   100,    -1,    -1,   103,   104,    -1,   106,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   126,    -1,    -1,
     129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,     3,
       4,   170,   171,   172,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,    -1,    23,
      -1,    25,    -1,    -1,    28,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,    -1,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    81,    82,    -1,
      84,    85,    -1,    87,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    97,    -1,    99,    -1,    -1,    -1,    -1,
      -1,   105,    -1,     3,     4,    -1,   110,   111,   112,    -1,
      -1,   115,    -1,    -1,   118,   119,   120,    -1,   122,    -1,
      20,    -1,    -1,    23,    -1,    25,   130,    -1,    28,   133,
      30,    -1,    -1,    -1,   138,    -1,    -1,   141,   142,   143,
      -1,    -1,   146,   147,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    52,   157,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    81,    82,    -1,    84,    85,    -1,    87,    -1,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,    99,
      -1,    -1,    -1,    -1,    -1,   105,    -1,     3,     4,    -1,
     110,   111,   112,    -1,    -1,   115,    -1,    -1,   118,   119,
     120,    -1,   122,    -1,    20,    -1,    -1,    23,    -1,    25,
     130,    -1,    28,   133,    30,    -1,    -1,    -1,   138,    -1,
      -1,   141,   142,   143,    -1,    -1,   146,   147,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    52,   157,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    81,    82,    -1,    84,    85,
      -1,    87,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    99,    -1,    -1,    -1,    -1,    -1,   105,
      -1,     3,     4,    -1,   110,   111,   112,    -1,    -1,   115,
      -1,    -1,   118,   119,   120,    -1,   122,    -1,    20,    -1,
      -1,    23,    -1,    25,   130,    -1,    28,   133,    30,    -1,
      -1,    -1,   138,    -1,    -1,   141,   142,   143,    -1,    -1,
     146,   147,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      52,   157,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    78,    -1,    -1,    81,
      82,    -1,    84,    85,    -1,    87,    -1,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    97,    -1,    99,    -1,    -1,
      -1,    -1,    -1,   105,    -1,     3,     4,    -1,   110,   111,
     112,    -1,    -1,   115,    -1,    -1,   118,   119,   120,    -1,
     122,    -1,    20,    -1,    -1,    23,    -1,    25,   130,    -1,
      28,   133,    30,    -1,    -1,    -1,   138,    -1,    -1,   141,
     142,   143,    -1,    -1,   146,   147,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    52,   157,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      78,    -1,    -1,    81,    82,    -1,    84,    85,    -1,    87,
      -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,
      -1,    99,    -1,    -1,    -1,    -1,    -1,   105,    -1,     3,
       4,    -1,   110,   111,   112,    -1,    -1,   115,    -1,    -1,
     118,   119,   120,    -1,   122,    -1,    20,    -1,    -1,    23,
      -1,    25,   130,    -1,    28,   133,    30,    -1,    -1,    -1,
     138,    -1,    -1,   141,   142,   143,    -1,    -1,   146,   147,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,   157,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    81,    82,    -1,
      84,    85,    -1,    87,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    97,    -1,    99,    -1,    -1,    -1,    -1,
      -1,   105,    -1,     3,     4,    -1,   110,   111,   112,    -1,
      -1,   115,    -1,    -1,   118,   119,   120,    -1,   122,    -1,
      20,    -1,    -1,    23,    -1,    25,   130,    -1,    28,   133,
      30,    -1,    -1,    -1,   138,    -1,    -1,   141,   142,   143,
      -1,    -1,   146,   147,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    52,   157,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    81,    82,    -1,    84,    85,    -1,    87,    -1,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,    99,
      -1,    -1,    -1,    -1,    -1,   105,    -1,     3,     4,    -1,
     110,   111,   112,    -1,    -1,   115,    -1,    -1,   118,   119,
     120,    -1,   122,    -1,    20,    -1,    -1,    23,    -1,    25,
     130,    -1,    28,   133,    30,    -1,    -1,    -1,   138,    -1,
      -1,   141,   142,   143,    -1,    -1,   146,   147,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    52,   157,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    81,    82,    -1,    84,    85,
      -1,    87,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    99,    -1,    -1,    -1,    -1,    -1,   105,
      -1,     3,     4,    -1,   110,   111,   112,    -1,    -1,   115,
      -1,    -1,   118,   119,   120,    -1,   122,    -1,    20,    -1,
      -1,    23,    -1,    25,   130,    -1,    28,   133,    30,    -1,
      -1,    -1,   138,    -1,    -1,   141,   142,   143,    -1,    -1,
     146,   147,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      52,   157,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    78,    -1,    -1,    81,
      82,    -1,    84,    85,    -1,    87,    -1,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    97,    -1,    99,    -1,    -1,
      -1,    -1,    -1,   105,    -1,     3,     4,    -1,   110,   111,
     112,    -1,    -1,   115,    -1,    -1,   118,   119,   120,    -1,
     122,    -1,    20,    -1,    -1,    23,    -1,    25,   130,    -1,
      28,   133,    30,    -1,    -1,    -1,   138,    -1,    -1,   141,
     142,   143,    -1,    -1,   146,   147,    -1,    -1,   150,    -1,
      -1,    49,    -1,    -1,    52,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      78,    -1,    -1,    81,    82,    -1,    84,    85,    -1,    87,
      -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,
      -1,    99,    -1,    -1,    -1,    -1,    -1,   105,    -1,     3,
       4,    -1,   110,   111,   112,    -1,    -1,   115,    -1,    -1,
     118,   119,   120,    -1,   122,    -1,    20,    -1,    -1,    23,
      -1,    25,   130,    -1,    28,   133,    30,    -1,    -1,    -1,
     138,    -1,    -1,   141,   142,   143,    -1,    -1,   146,   147,
      -1,    -1,   150,    -1,    -1,    49,    -1,    -1,    52,    -1,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    81,    82,    -1,
      84,    85,    -1,    87,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    97,    -1,    99,    -1,    -1,    -1,    -1,
      -1,   105,    -1,     3,     4,    -1,   110,   111,   112,    -1,
      -1,   115,    -1,    -1,   118,   119,   120,    -1,   122,    -1,
      20,    -1,    -1,    23,    -1,    25,   130,    -1,    28,   133,
      30,    -1,    -1,    -1,   138,    -1,    -1,   141,   142,   143,
      -1,    -1,   146,   147,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    52,    -1,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    81,    82,    -1,    84,    85,    -1,    87,    -1,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,    99,
      -1,    -1,    -1,    -1,    -1,   105,    -1,     3,     4,    -1,
     110,   111,   112,    -1,    -1,   115,    -1,    -1,   118,   119,
     120,    -1,   122,    -1,    20,    -1,    -1,    23,    -1,    25,
     130,    -1,    28,   133,    30,    -1,    -1,    -1,   138,    -1,
      -1,   141,   142,   143,    -1,    -1,   146,   147,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    52,    -1,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    81,    82,    -1,    84,    85,
      -1,    87,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    99,    -1,    -1,    -1,    -1,    -1,   105,
      -1,     3,     4,    -1,   110,   111,   112,    -1,    -1,   115,
      -1,    -1,   118,   119,   120,    -1,   122,    -1,    20,    -1,
      -1,    23,    -1,    25,   130,    -1,    28,   133,    30,    -1,
      -1,    -1,   138,    -1,    -1,   141,   142,   143,    -1,    -1,
     146,   147,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      52,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    78,    -1,    -1,    81,
      82,    -1,    84,    85,    -1,    87,    -1,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    97,    -1,    99,    -1,    -1,
      -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,   115,    -1,    -1,   118,   119,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,
      -1,   133,    -1,    -1,    -1,    -1,   138,    -1,    -1,   141,
     142,   143,    -1,    -1,   146,   147
  };

  const short
  Parser::yystos_[] =
  {
       0,    93,   175,     3,   176,     0,   149,   181,     4,     8,
       9,    10,    12,    13,    14,    15,    16,    17,    18,    19,
      27,    29,    34,    38,    40,    43,    44,    45,    51,    54,
      61,    68,    69,    71,    74,    75,    76,    77,    78,    79,
      85,    86,    87,    89,    91,    94,    95,    99,   102,   104,
     105,   107,   108,   109,   113,   114,   115,   118,   121,   122,
     123,   127,   128,   132,   134,   135,   136,   137,   139,   140,
     141,   144,   148,   150,   153,   157,   161,   164,   165,   167,
     168,   169,   171,   176,   177,   182,   183,   184,   185,   187,
     189,   190,   191,   192,   212,   219,   220,   242,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   263,   264,   265,   270,   271,
     272,   273,   276,   277,   278,   151,   152,   167,   242,   242,
     242,   153,   152,   158,   224,   152,   192,   224,   242,   153,
     153,   153,   153,   176,   153,   153,   153,   153,   153,   153,
     153,   224,    20,    23,    25,    28,    30,    49,    52,    54,
      55,    67,    73,    78,    81,    82,    84,    85,    87,    89,
      97,    99,   105,   110,   111,   112,   115,   118,   119,   120,
     122,   130,   133,   138,   141,   142,   143,   146,   147,   176,
     177,   199,   200,   221,   222,   223,   227,   228,   231,   235,
     239,   153,   224,    57,    58,   196,   201,   257,   153,    25,
      54,    78,    85,    87,    99,   105,   115,   118,   122,   141,
     177,   223,   242,   153,   153,   265,   269,   257,   153,   152,
     242,   153,   224,   153,   153,   153,   153,   152,   242,   149,
     183,   184,   192,   208,   209,   212,   153,   153,   153,   153,
     153,   224,   242,   153,   224,   153,   152,   242,   266,   268,
     257,   257,    14,    15,   260,   279,   257,   257,   173,   242,
     243,   244,   274,   275,    39,    63,    65,    67,   131,   152,
      46,    90,   100,   103,   126,   151,   160,    22,    53,    96,
      64,    83,   158,   159,   161,   162,   163,   116,   117,   164,
     165,   106,   157,   166,   167,    66,    70,    91,    98,   104,
     129,   153,   170,   171,   161,   285,   242,    15,   152,   152,
     156,   152,   156,   242,   223,   198,   199,   223,   152,   242,
     242,   176,    86,   186,   242,    62,   152,   242,   242,   242,
     242,   242,   242,   242,   243,   223,   176,   149,   158,   156,
     224,   224,   224,   153,   224,   224,   224,   224,   224,   224,
     153,   232,   224,   224,   285,   224,   224,   224,   224,   151,
      63,   226,   176,   242,   281,   282,   283,   223,   205,   223,
     242,   224,   224,   224,   224,   153,   242,   242,   242,   152,
     243,   223,   242,   186,   242,   242,   242,   152,   210,   211,
     212,    35,   217,   218,   222,   242,   242,   242,   242,   242,
     223,   152,   243,   223,   186,   242,   154,   154,   155,   161,
      11,   176,    61,   172,   155,   155,   172,   177,   223,   195,
     201,    25,   177,   223,   197,   201,   177,   246,   246,   248,
     246,   246,   246,   246,   249,   250,   250,   251,   251,   251,
     251,   252,   253,   254,   255,   255,   256,   256,   257,   257,
     257,   257,    54,   176,   262,   258,   258,   262,   243,   262,
     242,   278,     7,   284,   152,   242,   242,   154,   159,   225,
     152,   201,   225,   154,   154,    70,    25,   223,   152,   154,
     154,   178,   179,   154,   154,   154,   154,   154,   154,   154,
     225,   151,   176,   240,   241,   157,   223,    15,   157,   223,
     223,     9,   157,   223,   157,   223,   223,   157,   223,   223,
     157,   223,    42,    72,   202,   203,   204,   206,   149,   157,
     176,   223,   229,   230,    15,   157,   149,   157,   223,   223,
     157,   223,   157,   223,   242,   153,   151,   153,   188,   156,
     154,   155,   155,     4,     5,    60,   176,   193,   194,   154,
     223,   223,   223,   223,   243,   154,   155,   154,   225,   154,
     154,   154,   154,   154,   150,   212,   153,   208,   218,   154,
     154,   154,   154,   154,   154,   225,   154,   225,   152,   154,
     154,   267,   268,   280,   151,   176,   242,   275,   151,   177,
     205,   177,   151,   177,   205,   151,   156,   154,   153,   172,
     151,   152,   152,   153,   205,   153,   242,   176,   176,   242,
     208,   208,   152,     6,   153,   242,   151,   150,   155,   159,
     225,   225,   225,   225,   154,   225,   225,   225,   155,   225,
     225,   225,   225,   225,   225,   154,   155,   223,   233,   225,
     156,   155,   225,   225,   225,   223,   236,   237,   238,   225,
     225,   225,   225,   225,   225,   225,   152,   202,   242,   243,
     152,   242,   283,   223,   153,   225,   155,   225,   225,   154,
     242,   153,   149,   149,   223,   269,   153,   242,   208,   208,
     155,   167,   242,    70,   242,   151,   194,   151,   242,   151,
     188,   194,   223,   246,   243,   242,   242,   194,   243,   154,
     151,   151,   154,    50,   213,   213,   180,   266,   152,    15,
     241,   223,   204,   176,   150,   200,   223,   234,   223,   230,
     176,   150,   155,   154,   152,   154,   225,   202,   223,   154,
     266,    33,    44,   214,   215,   216,   214,   176,   266,   154,
     213,   213,   267,   242,   152,   242,   153,   242,   152,   242,
     152,   153,   285,   154,   154,   153,   154,   208,   242,   242,
     208,   208,   154,   225,   151,   207,   201,   176,   285,   238,
      24,   153,   154,   225,   154,   244,   156,   150,   216,   150,
     154,   154,   208,    68,   172,   152,   202,   152,   152,   202,
     152,   202,   213,   242,   285,   205,   285,   205,   281,   285,
     156,   208,   208,   213,   242,   154,   154,   154,   193,   152,
     154,   209,   208,   172,   285,   285,   285,   153,   209,   209,
     202,   154,   285,   152,   209
  };

  const short
  Parser::yyr1_[] =
  {
       0,   174,   175,   176,   177,   177,   179,   180,   178,   181,
     181,   181,   182,   182,   182,   182,   182,   182,   183,   184,
     184,   185,   185,   185,   185,   186,   186,   187,   187,   187,
     187,   188,   188,   189,   189,   189,   189,   190,   190,   191,
     191,   192,   192,   192,   192,   192,   193,   193,   194,   194,
     194,   195,   196,   197,   198,   199,   199,   200,   200,   201,
     201,   201,   202,   202,   203,   203,   204,   205,   206,   206,
     206,   207,   207,   208,   208,   209,   210,   210,   211,   211,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   213,   213,   214,   214,
     215,   215,   216,   216,   217,   217,   218,   218,   219,   219,
     219,   220,   221,   221,   221,   221,   221,   221,   221,   221,
     221,   221,   221,   221,   221,   221,   221,   221,   221,   221,
     221,   221,   221,   221,   221,   221,   221,   221,   221,   221,
     221,   221,   221,   221,   221,   221,   221,   221,   221,   221,
     221,   221,   221,   221,   221,   221,   221,   222,   223,   223,
     223,   224,   225,   226,   227,   228,   228,   229,   229,   230,
     230,   231,   232,   232,   233,   233,   234,   234,   234,   235,
     236,   236,   237,   237,   238,   239,   239,   240,   240,   240,
     241,   241,   242,   243,   243,   244,   244,   245,   246,   246,
     246,   246,   246,   246,   246,   247,   247,   248,   248,   249,
     249,   249,   250,   250,   250,   250,   250,   251,   251,   252,
     252,   253,   253,   254,   254,   254,   255,   255,   255,   256,
     256,   256,   256,   256,   257,   257,   257,   257,   257,   257,
     257,   258,   258,   258,   258,   258,   258,   258,   258,   258,
     258,   258,   259,   259,   259,   259,   259,   259,   259,   259,
     259,   259,   259,   259,   260,   260,   260,   260,   260,   260,
     261,   261,   261,   262,   262,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   265,
     266,   266,   266,   267,   267,   267,   268,   269,   270,   270,
     270,   270,   270,   271,   271,   272,   272,   273,   274,   274,
     275,   276,   277,   277,   279,   280,   278,   281,   281,   282,
     282,   283,   284,   284,   285,   285
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     5,     1,     1,     1,     0,     0,     3,     2,
       2,     0,     1,     1,     1,     1,     1,     1,     7,     6,
       7,     5,     5,     6,     6,     5,     5,     6,     6,     7,
       7,     3,     0,     3,     3,     2,     4,     3,     5,     2,
       4,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     8,     8,     8,     8,     1,     0,     1,     1,     1,
       1,     0,     1,     0,     3,     1,     5,     1,     1,     1,
       0,     2,     0,     1,     1,     3,     1,     0,     2,     1,
       2,     1,     2,     3,     3,     2,     2,     2,     2,     6,
       6,     8,     8,     6,     6,     7,     7,     7,     3,     3,
       5,     3,     5,     3,     3,     3,     2,     0,     1,     0,
       2,     1,     4,     3,     2,     1,     6,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     6,
       1,     3,     4,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     0,     7,     4,     4,     3,     1,     1,
       3,     5,     3,     0,     2,     0,     4,     9,     9,     5,
       1,     0,     3,     1,     3,     4,     4,     3,     2,     1,
       1,     3,     1,     1,     0,     3,     1,     1,     3,     3,
       3,     3,     3,     5,     1,     3,     1,     3,     1,     3,
       3,     1,     3,     3,     3,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     3,     1,     3,     3,     1,     3,
       3,     3,     3,     1,     2,     2,     2,     3,     2,     2,
       1,     4,     3,     6,     4,     3,     3,     3,     2,     2,
       3,     1,     4,     7,     4,     4,     2,     5,     2,     2,
       5,     4,     4,     1,     1,     1,     2,     7,     9,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     2,     1,     1,     3,     1,     4,     7,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     6,     3,
       1,     3,     0,     1,     3,     0,     1,     1,     3,     4,
       7,     4,     7,     4,     7,     4,     9,     3,     3,     1,
       4,     2,     3,     1,     0,     0,     5,     1,     0,     3,
       1,     3,     1,     3,     2,     0
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"<end of input>\"", "error", "\"invalid token\"", "\"identifier\"",
  "\"scoped identifier\"", "\"scoped ~finally\"", "\"dotted identifier\"",
  "\"attribute\"", "\"property\"", "\"string value\"", "\"bytes value\"",
  "\"regular expression value\"", "\"address value\"", "\"port value\"",
  "\"real value\"", "\"unsigned integer value\"", "\"bool value\"",
  "\"add\"", "\"assert\"", "\"assert-exception\"", "\"addr\"", "\"after\"",
  "\"&&\"", "\"any\"", "\"->\"", "\"auto\"", "\"at\"", "\"begin\"",
  "\"bool\"", "\"break\"", "\"bytes\"", "\"caddr\"", "\"callable\"",
  "\"case\"", "\"cast\"", "\"catch\"", "\"channel\"", "\"classifier\"",
  "\"Null\"", "\"const\"", "\"continue\"", "\"context\"", "\"copy\"",
  "\"declare\"", "\"default\"", "\"delete\"", "\"/=\"", "\"$$\"", "\"..\"",
  "\"real\"", "\"else\"", "\"end\"", "\"enum\"", "\"==\"", "\"error\"",
  "\"exception\"", "\"export\"", "\"extern\"", "\"extern-no-suspend\"",
  "\"file\"", "\"~finally\"", "\"for\"", "\"from\"", "\"function\"",
  "\">=\"", "\"global\"", "\"?.\"", "\"hook\"", "\"if\"", "\"import\"",
  "\"in\"", "\"init\"", "\"inout\"", "\"int\"", "\"int16\"", "\"int32\"",
  "\"int64\"", "\"int8\"", "\"interval\"", "\"interval_ns\"", "\"iosrc\"",
  "\"iterator\"", "\"const_iterator\"", "\"<=\"", "\"library type\"",
  "\"list\"", "\"local\"", "\"map\"", "\"match_token_state\"",
  "\"method\"", "\"-=\"", "\"--\"", "\"%\"", "\"module\"", "\"move\"",
  "\"new\"", "\"!=\"", "\"net\"", "\"!in\"", "\"optional\"", "\"||\"",
  "\"overlay\"", "\"pack\"", "\"+=\"", "\"++\"", "\"port\"", "\"**\"",
  "\"preinit\"", "\"private\"", "\"public\"", "\"strong_ref\"",
  "\"regexp\"", "\"result\"", "\"return\"", "\"scope\"", "\"set\"",
  "\"<<\"", "\">>\"", "\"stream\"", "\"string\"", "\"struct\"",
  "\"switch\"", "\"time\"", "\"time_ns\"", "\"timer\"", "\"timer_mgr\"",
  "\"*=\"", "\"throw\"", "\"try\"", "\".?\"", "\"tuple\"", "\"type\"",
  "\"typeinfo\"", "\"uint\"", "\"uint16\"", "\"uint32\"", "\"uint64\"",
  "\"uint8\"", "\"union\"", "\"unpack\"", "\"unset\"", "\"vector\"",
  "\"view\"", "\"void\"", "\"while\"", "\"with\"", "\"value_ref\"",
  "\"weak_ref\"", "\"yield\"", "'{'", "'}'", "'='", "';'", "'('", "')'",
  "','", "':'", "'*'", "'<'", "'>'", "'?'", "'|'", "'^'", "'&'", "'+'",
  "'-'", "'%'", "'/'", "'!'", "'~'", "'.'", "'['", "']'", "'$'", "$accept",
  "module", "local_id", "scoped_id", "dotted_id", "$@1", "$@2",
  "global_scope_items", "global_scope_decl", "type_decl", "constant_decl",
  "local_decl", "local_init_decl", "global_decl", "opt_type_arguments",
  "function_decl", "import_decl", "property_decl", "opt_linkage",
  "function_id", "scoped_function_id", "function_with_body",
  "method_with_body", "hook_with_body", "function_without_body",
  "opt_func_flavor", "func_flavor", "opt_func_cc", "opt_func_params",
  "func_params", "func_param", "func_result", "opt_func_param_kind",
  "opt_func_default_expr", "block", "braced_block", "opt_stmts", "stmts",
  "stmt", "opt_else_block", "opt_switch_cases", "switch_cases",
  "switch_case", "try_catches", "try_catch", "stmt_decl", "stmt_expr",
  "base_type_no_attrs", "base_type", "type", "type_param_begin",
  "type_param_end", "opt_type_flags", "function_type", "tuple_type",
  "tuple_type_elems", "tuple_type_elem", "struct_type",
  "opt_struct_params", "struct_fields", "struct_field", "union_type",
  "opt_union_fields", "union_fields", "union_field", "enum_type",
  "enum_labels", "enum_label", "expr", "opt_exprs", "exprs", "expr_0",
  "expr_1", "expr_2", "expr_3", "expr_4", "expr_5", "expr_6", "expr_7",
  "expr_8", "expr_9", "expr_a", "expr_b", "expr_c", "expr_d", "expr_e",
  "expr_f", "expr_g", "member_expr", "ctor", "ctor_expr", "tuple",
  "opt_tuple_elems1", "opt_tuple_elems2", "tuple_elem", "tuple_expr",
  "list", "set", "map", "struct_", "struct_elems", "struct_elem", "regexp",
  "re_patterns", "re_pattern_constant", "$@3", "$@4", "opt_map_elems",
  "map_elems", "map_elem", "attribute", "opt_attributes", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   266,   266,   274,   284,   285,   287,   289,   287,   294,
     296,   298,   302,   303,   304,   305,   306,   307,   309,   312,
     314,   318,   319,   320,   322,   327,   329,   333,   335,   337,
     339,   344,   345,   347,   349,   352,   353,   357,   358,   362,
     363,   365,   366,   367,   368,   369,   373,   374,   377,   378,
     379,   382,   389,   396,   403,   409,   410,   412,   413,   415,
     416,   417,   419,   420,   422,   423,   425,   429,   432,   433,
     434,   437,   438,   443,   444,   447,   449,   450,   452,   453,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     466,   468,   470,   472,   474,   476,   478,   480,   482,   484,
     485,   486,   487,   490,   498,   506,   516,   517,   520,   521,
     523,   524,   526,   527,   529,   530,   532,   534,   536,   537,
     538,   541,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   562,   563,   564,
     565,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   579,   580,   581,   582,   583,   584,   585,   586,
     588,   589,   591,   593,   594,   595,   596,   599,   603,   604,
     605,   609,   613,   616,   619,   623,   624,   628,   630,   634,
     635,   638,   641,   642,   644,   645,   647,   648,   652,   658,
     661,   662,   664,   665,   667,   669,   670,   672,   673,   674,
     677,   678,   683,   686,   687,   689,   690,   692,   695,   696,
     697,   698,   699,   700,   701,   703,   704,   706,   707,   709,
     710,   711,   713,   714,   715,   716,   717,   719,   720,   722,
     723,   725,   726,   728,   729,   730,   732,   733,   734,   736,
     737,   738,   739,   740,   742,   743,   744,   745,   746,   747,
     748,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   762,   763,   764,   765,   766,   767,   768,   769,
     770,   771,   772,   773,   775,   776,   777,   778,   780,   782,
     784,   785,   786,   789,   790,   794,   795,   796,   797,   798,
     803,   804,   805,   807,   808,   809,   814,   815,   817,   818,
     819,   820,   821,   822,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   842,
     845,   846,   847,   850,   851,   852,   855,   858,   860,   861,
     862,   864,   865,   868,   869,   872,   873,   876,   878,   879,
     881,   883,   885,   887,   890,   890,   890,   893,   894,   896,
     897,   899,   902,   903,   906,   907
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  Parser::symbol_kind_type
  Parser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const unsigned char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   168,     2,     2,   173,   166,   163,     2,
     153,   154,   157,   164,   155,   165,   170,   167,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   156,   152,
     158,   151,   159,   160,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   171,     2,   172,   162,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   149,   161,   150,   169,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148
    };
    // Last valid token kind.
    const int code_max = 403;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return YY_CAST (symbol_kind_type, translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 27 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"
} } } // hilti::detail::parser
#line 6560 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc"

#line 909 "/builddir/build/BUILD/zeek-6.0.3/build/auxil/spicy/hilti/src/autogen/__parser.cc.pp"


void hilti::detail::parser::Parser::error(const Parser::location_type& l, const std::string& m) {
    driver->error(m, toMeta(l));
}
